/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "../src/intel/compiler/brw_gram.y"

/*
 * Copyright © 2018 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include "brw_asm_internal.h"

#undef yyerror
#ifdef YYBYACC
struct YYLTYPE;
void yyerror (struct YYLTYPE *, char *);
#else
void yyerror (char *);
#endif

#undef ALIGN16

#define YYLTYPE YYLTYPE
typedef struct YYLTYPE
{
   int first_line;
   int first_column;
   int last_line;
   int last_column;
} YYLTYPE;

enum message_level {
   WARN,
   ERROR,
};

int yydebug = 1;

static void
message(enum message_level level, YYLTYPE *location,
        const char *fmt, ...)
{
   static const char *level_str[] = { "warning", "error" };
   va_list args;

   if (location)
      fprintf(stderr, "%s:%d:%d: %s: ", input_filename,
              location->first_line,
              location->first_column, level_str[level]);
   else
      fprintf(stderr, "%s:%s: ", input_filename, level_str[level]);

   va_start(args, fmt);
   vfprintf(stderr, fmt, args);
   va_end(args);
}

#define warn(flag, l, fmt, ...)                 \
   do {                                         \
      if (warning_flags & WARN_ ## flag)        \
         message(WARN, l, fmt, ## __VA_ARGS__); \
   } while (0)

#define error(l, fmt, ...)                      \
   do {                                         \
      message(ERROR, l, fmt, ## __VA_ARGS__);   \
   } while (0)

static bool
isPowerofTwo(unsigned int x)
{
   return x && (!(x & (x - 1)));
}

static struct brw_reg
set_direct_src_operand(struct brw_reg *reg, int type)
{
   return brw_make_reg(reg->file,
                       reg->nr,
                       reg->subnr,
                       0,      // negate
                       0,      // abs
                       type,
                       0,      // vstride
                       0,      // width
                       0,      // hstride
                       BRW_SWIZZLE_NOOP,
                       WRITEMASK_XYZW);
}

static void
i965_asm_unary_instruction(int opcode, struct brw_codegen *p,
                           struct brw_reg dest, struct brw_reg src0)
{
   switch (opcode) {
   case BRW_OPCODE_BFREV:
      brw_BFREV(p, dest, src0);
      break;
   case BRW_OPCODE_CBIT:
      brw_CBIT(p, dest, src0);
      break;
   case BRW_OPCODE_MOV:
      brw_MOV(p, dest, src0);
      break;
   case BRW_OPCODE_FBL:
      brw_FBL(p, dest, src0);
      break;
   case BRW_OPCODE_FRC:
      brw_FRC(p, dest, src0);
      break;
   case BRW_OPCODE_FBH:
      brw_FBH(p, dest, src0);
      break;
   case BRW_OPCODE_NOT:
      brw_NOT(p, dest, src0);
      break;
   case BRW_OPCODE_RNDE:
      brw_RNDE(p, dest, src0);
      break;
   case BRW_OPCODE_RNDZ:
      brw_RNDZ(p, dest, src0);
      break;
   case BRW_OPCODE_RNDD:
      brw_RNDD(p, dest, src0);
      break;
   case BRW_OPCODE_LZD:
      brw_LZD(p, dest, src0);
      break;
   case BRW_OPCODE_RNDU:
      fprintf(stderr, "Opcode BRW_OPCODE_RNDU unhandled\n");
      break;
   default:
      fprintf(stderr, "Unsupported unary opcode\n");
   }
}

static void
i965_asm_binary_instruction(int opcode,
                            struct brw_codegen *p,
                            struct brw_reg dest,
                            struct brw_reg src0,
                            struct brw_reg src1)
{
   switch (opcode) {
   case BRW_OPCODE_ADDC:
      brw_ADDC(p, dest, src0, src1);
      break;
   case BRW_OPCODE_BFI1:
      brw_BFI1(p, dest, src0, src1);
      break;
   case BRW_OPCODE_DP2:
      brw_DP2(p, dest, src0, src1);
      break;
   case BRW_OPCODE_DP3:
      brw_DP3(p, dest, src0, src1);
      break;
   case BRW_OPCODE_DP4:
      brw_DP4(p, dest, src0, src1);
      break;
   case BRW_OPCODE_DPH:
      brw_DPH(p, dest, src0, src1);
      break;
   case BRW_OPCODE_LINE:
      brw_LINE(p, dest, src0, src1);
      break;
   case BRW_OPCODE_MAC:
      brw_MAC(p, dest, src0, src1);
      break;
   case BRW_OPCODE_MACH:
      brw_MACH(p, dest, src0, src1);
      break;
   case BRW_OPCODE_PLN:
      brw_PLN(p, dest, src0, src1);
      break;
   case BRW_OPCODE_ROL:
      brw_ROL(p, dest, src0, src1);
      break;
   case BRW_OPCODE_ROR:
      brw_ROR(p, dest, src0, src1);
      break;
   case BRW_OPCODE_SUBB:
      brw_SUBB(p, dest, src0, src1);
      break;
   case BRW_OPCODE_ADD:
      brw_ADD(p, dest, src0, src1);
      break;
   case BRW_OPCODE_CMP:
      /* Third parameter is conditional modifier
       * which gets updated later
       */
      brw_CMP(p, dest, 0, src0, src1);
      break;
   case BRW_OPCODE_AND:
      brw_AND(p, dest, src0, src1);
      break;
   case BRW_OPCODE_ASR:
      brw_ASR(p, dest, src0, src1);
      break;
   case BRW_OPCODE_AVG:
      brw_AVG(p, dest, src0, src1);
      break;
   case BRW_OPCODE_OR:
      brw_OR(p, dest, src0, src1);
      break;
   case BRW_OPCODE_SEL:
      brw_SEL(p, dest, src0, src1);
      break;
   case BRW_OPCODE_SHL:
      brw_SHL(p, dest, src0, src1);
      break;
   case BRW_OPCODE_SHR:
      brw_SHR(p, dest, src0, src1);
      break;
   case BRW_OPCODE_XOR:
      brw_XOR(p, dest, src0, src1);
      break;
   case BRW_OPCODE_MUL:
      brw_MUL(p, dest, src0, src1);
      break;
   default:
      fprintf(stderr, "Unsupported binary opcode\n");
   }
}

static void
i965_asm_ternary_instruction(int opcode,
                             struct brw_codegen *p,
                             struct brw_reg dest,
                             struct brw_reg src0,
                             struct brw_reg src1,
                             struct brw_reg src2)
{
   switch (opcode) {
   case BRW_OPCODE_MAD:
      brw_MAD(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_CSEL:
      brw_CSEL(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_LRP:
      brw_LRP(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_BFE:
      brw_BFE(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_BFI2:
      brw_BFI2(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_DP4A:
      brw_DP4A(p, dest, src0, src1, src2);
      break;
   case BRW_OPCODE_ADD3:
      brw_ADD3(p, dest, src0, src1, src2);
      break;
   default:
      fprintf(stderr, "Unsupported ternary opcode\n");
   }
}

static void
i965_asm_set_instruction_options(struct brw_codegen *p,
                                 struct options options)
{
   brw_eu_inst_set_access_mode(p->devinfo, brw_last_inst,
                               options.access_mode);
   brw_eu_inst_set_mask_control(p->devinfo, brw_last_inst,
                                options.mask_control);
   if (p->devinfo->ver < 12) {
      brw_eu_inst_set_thread_control(p->devinfo, brw_last_inst,
                                     options.thread_control);
      brw_eu_inst_set_no_dd_check(p->devinfo, brw_last_inst,
                                  options.no_dd_check);
      brw_eu_inst_set_no_dd_clear(p->devinfo, brw_last_inst,
                                  options.no_dd_clear);
   } else {
      enum opcode opcode = brw_eu_inst_opcode(p->isa, brw_last_inst);
      brw_eu_inst_set_swsb(p->devinfo, brw_last_inst,
                           tgl_swsb_encode(p->devinfo, options.depinfo, opcode));
   }
   brw_eu_inst_set_debug_control(p->devinfo, brw_last_inst,
                                 options.debug_control);
   if (brw_has_branch_ctrl(p->devinfo, brw_eu_inst_opcode(p->isa, brw_last_inst))) {
      if (options.acc_wr_control)
         error(NULL, "Instruction does not support AccWrEnable\n");

      brw_eu_inst_set_branch_control(p->devinfo, brw_last_inst,
                                     options.branch_control);
   } else if (options.branch_control) {
      error(NULL, "Instruction does not support BranchCtrl\n");
   } else if (p->devinfo->ver < 20) {
      brw_eu_inst_set_acc_wr_control(p->devinfo, brw_last_inst,
                                     options.acc_wr_control);
   }
   brw_eu_inst_set_cmpt_control(p->devinfo, brw_last_inst,
                                options.compaction);
}


#line 388 "src/intel/compiler/brw_gram.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "brw_gram.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABS = 3,                        /* ABS  */
  YYSYMBOL_COLON = 4,                      /* COLON  */
  YYSYMBOL_COMMA = 5,                      /* COMMA  */
  YYSYMBOL_DOT = 6,                        /* DOT  */
  YYSYMBOL_LANGLE = 7,                     /* LANGLE  */
  YYSYMBOL_RANGLE = 8,                     /* RANGLE  */
  YYSYMBOL_LCURLY = 9,                     /* LCURLY  */
  YYSYMBOL_RCURLY = 10,                    /* RCURLY  */
  YYSYMBOL_LPAREN = 11,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 12,                    /* RPAREN  */
  YYSYMBOL_LSQUARE = 13,                   /* LSQUARE  */
  YYSYMBOL_RSQUARE = 14,                   /* RSQUARE  */
  YYSYMBOL_PLUS = 15,                      /* PLUS  */
  YYSYMBOL_MINUS = 16,                     /* MINUS  */
  YYSYMBOL_SEMICOLON = 17,                 /* SEMICOLON  */
  YYSYMBOL_ASSIGN = 18,                    /* ASSIGN  */
  YYSYMBOL_TYPE_B = 19,                    /* TYPE_B  */
  YYSYMBOL_TYPE_UB = 20,                   /* TYPE_UB  */
  YYSYMBOL_TYPE_W = 21,                    /* TYPE_W  */
  YYSYMBOL_TYPE_UW = 22,                   /* TYPE_UW  */
  YYSYMBOL_TYPE_D = 23,                    /* TYPE_D  */
  YYSYMBOL_TYPE_UD = 24,                   /* TYPE_UD  */
  YYSYMBOL_TYPE_Q = 25,                    /* TYPE_Q  */
  YYSYMBOL_TYPE_UQ = 26,                   /* TYPE_UQ  */
  YYSYMBOL_TYPE_V = 27,                    /* TYPE_V  */
  YYSYMBOL_TYPE_UV = 28,                   /* TYPE_UV  */
  YYSYMBOL_TYPE_F = 29,                    /* TYPE_F  */
  YYSYMBOL_TYPE_HF = 30,                   /* TYPE_HF  */
  YYSYMBOL_TYPE_BF = 31,                   /* TYPE_BF  */
  YYSYMBOL_TYPE_DF = 32,                   /* TYPE_DF  */
  YYSYMBOL_TYPE_VF = 33,                   /* TYPE_VF  */
  YYSYMBOL_JUMP_LABEL = 34,                /* JUMP_LABEL  */
  YYSYMBOL_JUMP_LABEL_TARGET = 35,         /* JUMP_LABEL_TARGET  */
  YYSYMBOL_JIP = 36,                       /* JIP  */
  YYSYMBOL_UIP = 37,                       /* UIP  */
  YYSYMBOL_ADD = 38,                       /* ADD  */
  YYSYMBOL_ADD3 = 39,                      /* ADD3  */
  YYSYMBOL_ADDC = 40,                      /* ADDC  */
  YYSYMBOL_AND = 41,                       /* AND  */
  YYSYMBOL_ASR = 42,                       /* ASR  */
  YYSYMBOL_AVG = 43,                       /* AVG  */
  YYSYMBOL_BFE = 44,                       /* BFE  */
  YYSYMBOL_BFI1 = 45,                      /* BFI1  */
  YYSYMBOL_BFI2 = 46,                      /* BFI2  */
  YYSYMBOL_BFB = 47,                       /* BFB  */
  YYSYMBOL_BFREV = 48,                     /* BFREV  */
  YYSYMBOL_BRC = 49,                       /* BRC  */
  YYSYMBOL_BRD = 50,                       /* BRD  */
  YYSYMBOL_BREAK = 51,                     /* BREAK  */
  YYSYMBOL_CALL = 52,                      /* CALL  */
  YYSYMBOL_CALLA = 53,                     /* CALLA  */
  YYSYMBOL_CASE = 54,                      /* CASE  */
  YYSYMBOL_CBIT = 55,                      /* CBIT  */
  YYSYMBOL_CMP = 56,                       /* CMP  */
  YYSYMBOL_CMPN = 57,                      /* CMPN  */
  YYSYMBOL_CONT = 58,                      /* CONT  */
  YYSYMBOL_CSEL = 59,                      /* CSEL  */
  YYSYMBOL_DIM = 60,                       /* DIM  */
  YYSYMBOL_DO = 61,                        /* DO  */
  YYSYMBOL_DPAS = 62,                      /* DPAS  */
  YYSYMBOL_DP2 = 63,                       /* DP2  */
  YYSYMBOL_DP3 = 64,                       /* DP3  */
  YYSYMBOL_DP4 = 65,                       /* DP4  */
  YYSYMBOL_DP4A = 66,                      /* DP4A  */
  YYSYMBOL_DPH = 67,                       /* DPH  */
  YYSYMBOL_ELSE = 68,                      /* ELSE  */
  YYSYMBOL_ENDIF = 69,                     /* ENDIF  */
  YYSYMBOL_FBH = 70,                       /* FBH  */
  YYSYMBOL_FBL = 71,                       /* FBL  */
  YYSYMBOL_FORK = 72,                      /* FORK  */
  YYSYMBOL_FRC = 73,                       /* FRC  */
  YYSYMBOL_GOTO = 74,                      /* GOTO  */
  YYSYMBOL_HALT = 75,                      /* HALT  */
  YYSYMBOL_IF = 76,                        /* IF  */
  YYSYMBOL_ILLEGAL = 77,                   /* ILLEGAL  */
  YYSYMBOL_JMPI = 78,                      /* JMPI  */
  YYSYMBOL_JOIN = 79,                      /* JOIN  */
  YYSYMBOL_LINE = 80,                      /* LINE  */
  YYSYMBOL_LRP = 81,                       /* LRP  */
  YYSYMBOL_LZD = 82,                       /* LZD  */
  YYSYMBOL_MAC = 83,                       /* MAC  */
  YYSYMBOL_MACH = 84,                      /* MACH  */
  YYSYMBOL_MAD = 85,                       /* MAD  */
  YYSYMBOL_MADM = 86,                      /* MADM  */
  YYSYMBOL_MATH = 87,                      /* MATH  */
  YYSYMBOL_MOV = 88,                       /* MOV  */
  YYSYMBOL_MOVI = 89,                      /* MOVI  */
  YYSYMBOL_MUL = 90,                       /* MUL  */
  YYSYMBOL_MREST = 91,                     /* MREST  */
  YYSYMBOL_MSAVE = 92,                     /* MSAVE  */
  YYSYMBOL_NENOP = 93,                     /* NENOP  */
  YYSYMBOL_NOP = 94,                       /* NOP  */
  YYSYMBOL_NOT = 95,                       /* NOT  */
  YYSYMBOL_OR = 96,                        /* OR  */
  YYSYMBOL_PLN = 97,                       /* PLN  */
  YYSYMBOL_POP = 98,                       /* POP  */
  YYSYMBOL_PUSH = 99,                      /* PUSH  */
  YYSYMBOL_RET = 100,                      /* RET  */
  YYSYMBOL_RNDD = 101,                     /* RNDD  */
  YYSYMBOL_RNDE = 102,                     /* RNDE  */
  YYSYMBOL_RNDU = 103,                     /* RNDU  */
  YYSYMBOL_RNDZ = 104,                     /* RNDZ  */
  YYSYMBOL_ROL = 105,                      /* ROL  */
  YYSYMBOL_ROR = 106,                      /* ROR  */
  YYSYMBOL_SEL = 107,                      /* SEL  */
  YYSYMBOL_SENDS = 108,                    /* SENDS  */
  YYSYMBOL_SENDSC = 109,                   /* SENDSC  */
  YYSYMBOL_SHL = 110,                      /* SHL  */
  YYSYMBOL_SHR = 111,                      /* SHR  */
  YYSYMBOL_SMOV = 112,                     /* SMOV  */
  YYSYMBOL_SUBB = 113,                     /* SUBB  */
  YYSYMBOL_SYNC = 114,                     /* SYNC  */
  YYSYMBOL_SEND_GFX4 = 115,                /* SEND_GFX4  */
  YYSYMBOL_SENDC_GFX4 = 116,               /* SENDC_GFX4  */
  YYSYMBOL_SEND_GFX12 = 117,               /* SEND_GFX12  */
  YYSYMBOL_SENDC_GFX12 = 118,              /* SENDC_GFX12  */
  YYSYMBOL_WAIT = 119,                     /* WAIT  */
  YYSYMBOL_WHILE = 120,                    /* WHILE  */
  YYSYMBOL_XOR = 121,                      /* XOR  */
  YYSYMBOL_COS = 122,                      /* COS  */
  YYSYMBOL_EXP = 123,                      /* EXP  */
  YYSYMBOL_FDIV = 124,                     /* FDIV  */
  YYSYMBOL_INV = 125,                      /* INV  */
  YYSYMBOL_INVM = 126,                     /* INVM  */
  YYSYMBOL_INTDIV = 127,                   /* INTDIV  */
  YYSYMBOL_INTDIVMOD = 128,                /* INTDIVMOD  */
  YYSYMBOL_INTMOD = 129,                   /* INTMOD  */
  YYSYMBOL_LOG = 130,                      /* LOG  */
  YYSYMBOL_POW = 131,                      /* POW  */
  YYSYMBOL_RSQ = 132,                      /* RSQ  */
  YYSYMBOL_RSQRTM = 133,                   /* RSQRTM  */
  YYSYMBOL_SIN = 134,                      /* SIN  */
  YYSYMBOL_SINCOS = 135,                   /* SINCOS  */
  YYSYMBOL_SQRT = 136,                     /* SQRT  */
  YYSYMBOL_ALLRD = 137,                    /* ALLRD  */
  YYSYMBOL_ALLWR = 138,                    /* ALLWR  */
  YYSYMBOL_FENCE = 139,                    /* FENCE  */
  YYSYMBOL_BAR = 140,                      /* BAR  */
  YYSYMBOL_HOST = 141,                     /* HOST  */
  YYSYMBOL_HDC0 = 142,                     /* HDC0  */
  YYSYMBOL_HDC1 = 143,                     /* HDC1  */
  YYSYMBOL_HDC2 = 144,                     /* HDC2  */
  YYSYMBOL_HDC_RO = 145,                   /* HDC_RO  */
  YYSYMBOL_GATEWAY = 146,                  /* GATEWAY  */
  YYSYMBOL_PIXEL_INTERP = 147,             /* PIXEL_INTERP  */
  YYSYMBOL_RENDER = 148,                   /* RENDER  */
  YYSYMBOL_SAMPLER = 149,                  /* SAMPLER  */
  YYSYMBOL_TS_BTD = 150,                   /* TS_BTD  */
  YYSYMBOL_URB = 151,                      /* URB  */
  YYSYMBOL_RT_ACCEL = 152,                 /* RT_ACCEL  */
  YYSYMBOL_SLM = 153,                      /* SLM  */
  YYSYMBOL_TGM = 154,                      /* TGM  */
  YYSYMBOL_UGM = 155,                      /* UGM  */
  YYSYMBOL_MSGDESC_BEGIN = 156,            /* MSGDESC_BEGIN  */
  YYSYMBOL_SRC1_LEN = 157,                 /* SRC1_LEN  */
  YYSYMBOL_EX_BSO = 158,                   /* EX_BSO  */
  YYSYMBOL_MSGDESC_END = 159,              /* MSGDESC_END  */
  YYSYMBOL_EQUAL = 160,                    /* EQUAL  */
  YYSYMBOL_GREATER = 161,                  /* GREATER  */
  YYSYMBOL_GREATER_EQUAL = 162,            /* GREATER_EQUAL  */
  YYSYMBOL_LESS = 163,                     /* LESS  */
  YYSYMBOL_LESS_EQUAL = 164,               /* LESS_EQUAL  */
  YYSYMBOL_NOT_EQUAL = 165,                /* NOT_EQUAL  */
  YYSYMBOL_NOT_ZERO = 166,                 /* NOT_ZERO  */
  YYSYMBOL_OVERFLOW = 167,                 /* OVERFLOW  */
  YYSYMBOL_UNORDERED = 168,                /* UNORDERED  */
  YYSYMBOL_ZERO = 169,                     /* ZERO  */
  YYSYMBOL_ALIGN1 = 170,                   /* ALIGN1  */
  YYSYMBOL_ALIGN16 = 171,                  /* ALIGN16  */
  YYSYMBOL_ACCWREN = 172,                  /* ACCWREN  */
  YYSYMBOL_CMPTCTRL = 173,                 /* CMPTCTRL  */
  YYSYMBOL_WECTRL = 174,                   /* WECTRL  */
  YYSYMBOL_BREAKPOINT = 175,               /* BREAKPOINT  */
  YYSYMBOL_NODDCLR = 176,                  /* NODDCLR  */
  YYSYMBOL_NODDCHK = 177,                  /* NODDCHK  */
  YYSYMBOL_EOT = 178,                      /* EOT  */
  YYSYMBOL_MASK_DISABLE = 179,             /* MASK_DISABLE  */
  YYSYMBOL_ANYV = 180,                     /* ANYV  */
  YYSYMBOL_ALLV = 181,                     /* ALLV  */
  YYSYMBOL_ANY2H = 182,                    /* ANY2H  */
  YYSYMBOL_ALL2H = 183,                    /* ALL2H  */
  YYSYMBOL_ANY4H = 184,                    /* ANY4H  */
  YYSYMBOL_ALL4H = 185,                    /* ALL4H  */
  YYSYMBOL_ANY8H = 186,                    /* ANY8H  */
  YYSYMBOL_ALL8H = 187,                    /* ALL8H  */
  YYSYMBOL_ANY16H = 188,                   /* ANY16H  */
  YYSYMBOL_ALL16H = 189,                   /* ALL16H  */
  YYSYMBOL_ANY32H = 190,                   /* ANY32H  */
  YYSYMBOL_ALL32H = 191,                   /* ALL32H  */
  YYSYMBOL_ROUND_INCREMENT = 192,          /* ROUND_INCREMENT  */
  YYSYMBOL_SATURATE = 193,                 /* SATURATE  */
  YYSYMBOL_ATOMIC = 194,                   /* ATOMIC  */
  YYSYMBOL_SWITCH = 195,                   /* SWITCH  */
  YYSYMBOL_BRANCH_CTRL = 196,              /* BRANCH_CTRL  */
  YYSYMBOL_QTR_2Q = 197,                   /* QTR_2Q  */
  YYSYMBOL_QTR_3Q = 198,                   /* QTR_3Q  */
  YYSYMBOL_QTR_4Q = 199,                   /* QTR_4Q  */
  YYSYMBOL_QTR_2H = 200,                   /* QTR_2H  */
  YYSYMBOL_QTR_2N = 201,                   /* QTR_2N  */
  YYSYMBOL_QTR_3N = 202,                   /* QTR_3N  */
  YYSYMBOL_QTR_4N = 203,                   /* QTR_4N  */
  YYSYMBOL_QTR_5N = 204,                   /* QTR_5N  */
  YYSYMBOL_QTR_6N = 205,                   /* QTR_6N  */
  YYSYMBOL_QTR_7N = 206,                   /* QTR_7N  */
  YYSYMBOL_QTR_8N = 207,                   /* QTR_8N  */
  YYSYMBOL_X = 208,                        /* X  */
  YYSYMBOL_Y = 209,                        /* Y  */
  YYSYMBOL_Z = 210,                        /* Z  */
  YYSYMBOL_W = 211,                        /* W  */
  YYSYMBOL_GENREGFILE = 212,               /* GENREGFILE  */
  YYSYMBOL_VxH = 213,                      /* VxH  */
  YYSYMBOL_GENREG = 214,                   /* GENREG  */
  YYSYMBOL_ADDRREG = 215,                  /* ADDRREG  */
  YYSYMBOL_ACCREG = 216,                   /* ACCREG  */
  YYSYMBOL_FLAGREG = 217,                  /* FLAGREG  */
  YYSYMBOL_NOTIFYREG = 218,                /* NOTIFYREG  */
  YYSYMBOL_STATEREG = 219,                 /* STATEREG  */
  YYSYMBOL_CONTROLREG = 220,               /* CONTROLREG  */
  YYSYMBOL_IPREG = 221,                    /* IPREG  */
  YYSYMBOL_PERFORMANCEREG = 222,           /* PERFORMANCEREG  */
  YYSYMBOL_THREADREG = 223,                /* THREADREG  */
  YYSYMBOL_CHANNELENABLEREG = 224,         /* CHANNELENABLEREG  */
  YYSYMBOL_MASKREG = 225,                  /* MASKREG  */
  YYSYMBOL_SCALARREG = 226,                /* SCALARREG  */
  YYSYMBOL_INTEGER = 227,                  /* INTEGER  */
  YYSYMBOL_LONG = 228,                     /* LONG  */
  YYSYMBOL_NULL_TOKEN = 229,               /* NULL_TOKEN  */
  YYSYMBOL_SUBREGNUM = 230,                /* SUBREGNUM  */
  YYSYMBOL_EMPTYEXECSIZE = 231,            /* EMPTYEXECSIZE  */
  YYSYMBOL_REG_DIST_CURRENT = 232,         /* REG_DIST_CURRENT  */
  YYSYMBOL_REG_DIST_FLOAT = 233,           /* REG_DIST_FLOAT  */
  YYSYMBOL_REG_DIST_INT = 234,             /* REG_DIST_INT  */
  YYSYMBOL_REG_DIST_LONG = 235,            /* REG_DIST_LONG  */
  YYSYMBOL_REG_DIST_ALL = 236,             /* REG_DIST_ALL  */
  YYSYMBOL_REG_DIST_MATH = 237,            /* REG_DIST_MATH  */
  YYSYMBOL_REG_DIST_SCALAR = 238,          /* REG_DIST_SCALAR  */
  YYSYMBOL_SBID_ALLOC = 239,               /* SBID_ALLOC  */
  YYSYMBOL_SBID_WAIT_SRC = 240,            /* SBID_WAIT_SRC  */
  YYSYMBOL_SBID_WAIT_DST = 241,            /* SBID_WAIT_DST  */
  YYSYMBOL_DPAS_PARAMS = 242,              /* DPAS_PARAMS  */
  YYSYMBOL_YYACCEPT = 243,                 /* $accept  */
  YYSYMBOL_ROOT = 244,                     /* ROOT  */
  YYSYMBOL_instrseq = 245,                 /* instrseq  */
  YYSYMBOL_instruction = 246,              /* instruction  */
  YYSYMBOL_relocatableinstruction = 247,   /* relocatableinstruction  */
  YYSYMBOL_illegalinstruction = 248,       /* illegalinstruction  */
  YYSYMBOL_unaryinstruction = 249,         /* unaryinstruction  */
  YYSYMBOL_unaryopcodes = 250,             /* unaryopcodes  */
  YYSYMBOL_binaryinstruction = 251,        /* binaryinstruction  */
  YYSYMBOL_binaryopcodes = 252,            /* binaryopcodes  */
  YYSYMBOL_binaryaccinstruction = 253,     /* binaryaccinstruction  */
  YYSYMBOL_binaryaccopcodes = 254,         /* binaryaccopcodes  */
  YYSYMBOL_mathinstruction = 255,          /* mathinstruction  */
  YYSYMBOL_math_function = 256,            /* math_function  */
  YYSYMBOL_nopinstruction = 257,           /* nopinstruction  */
  YYSYMBOL_ternaryinstruction = 258,       /* ternaryinstruction  */
  YYSYMBOL_ternaryopcodes = 259,           /* ternaryopcodes  */
  YYSYMBOL_waitinstruction = 260,          /* waitinstruction  */
  YYSYMBOL_sendinstruction = 261,          /* sendinstruction  */
  YYSYMBOL_sendop = 262,                   /* sendop  */
  YYSYMBOL_sendsop = 263,                  /* sendsop  */
  YYSYMBOL_sendopcode = 264,               /* sendopcode  */
  YYSYMBOL_sendsopcode = 265,              /* sendsopcode  */
  YYSYMBOL_sharedfunction = 266,           /* sharedfunction  */
  YYSYMBOL_exp2 = 267,                     /* exp2  */
  YYSYMBOL_desc = 268,                     /* desc  */
  YYSYMBOL_ex_desc = 269,                  /* ex_desc  */
  YYSYMBOL_reg32a = 270,                   /* reg32a  */
  YYSYMBOL_jumpinstruction = 271,          /* jumpinstruction  */
  YYSYMBOL_branchinstruction = 272,        /* branchinstruction  */
  YYSYMBOL_joininstruction = 273,          /* joininstruction  */
  YYSYMBOL_breakinstruction = 274,         /* breakinstruction  */
  YYSYMBOL_loopinstruction = 275,          /* loopinstruction  */
  YYSYMBOL_syncinstruction = 276,          /* syncinstruction  */
  YYSYMBOL_sync_function = 277,            /* sync_function  */
  YYSYMBOL_sync_arg = 278,                 /* sync_arg  */
  YYSYMBOL_relativelocation2 = 279,        /* relativelocation2  */
  YYSYMBOL_jumplabeltarget = 280,          /* jumplabeltarget  */
  YYSYMBOL_dst = 281,                      /* dst  */
  YYSYMBOL_dstoperand = 282,               /* dstoperand  */
  YYSYMBOL_dstoperandex = 283,             /* dstoperandex  */
  YYSYMBOL_dstoperandex_typed = 284,       /* dstoperandex_typed  */
  YYSYMBOL_dstreg = 285,                   /* dstreg  */
  YYSYMBOL_srcaccimm = 286,                /* srcaccimm  */
  YYSYMBOL_immreg = 287,                   /* immreg  */
  YYSYMBOL_reg32 = 288,                    /* reg32  */
  YYSYMBOL_payload = 289,                  /* payload  */
  YYSYMBOL_src = 290,                      /* src  */
  YYSYMBOL_srcacc = 291,                   /* srcacc  */
  YYSYMBOL_srcimm = 292,                   /* srcimm  */
  YYSYMBOL_directsrcaccoperand = 293,      /* directsrcaccoperand  */
  YYSYMBOL_srcarcoperandex = 294,          /* srcarcoperandex  */
  YYSYMBOL_srcarcoperandex_typed = 295,    /* srcarcoperandex_typed  */
  YYSYMBOL_indirectsrcoperand = 296,       /* indirectsrcoperand  */
  YYSYMBOL_directgenreg_list = 297,        /* directgenreg_list  */
  YYSYMBOL_directsrcoperand = 298,         /* directsrcoperand  */
  YYSYMBOL_addrparam = 299,                /* addrparam  */
  YYSYMBOL_exp = 300,                      /* exp  */
  YYSYMBOL_subregnum = 301,                /* subregnum  */
  YYSYMBOL_directgenreg = 302,             /* directgenreg  */
  YYSYMBOL_indirectgenreg = 303,           /* indirectgenreg  */
  YYSYMBOL_addrreg = 304,                  /* addrreg  */
  YYSYMBOL_accreg = 305,                   /* accreg  */
  YYSYMBOL_flagreg = 306,                  /* flagreg  */
  YYSYMBOL_maskreg = 307,                  /* maskreg  */
  YYSYMBOL_notifyreg = 308,                /* notifyreg  */
  YYSYMBOL_scalarreg = 309,                /* scalarreg  */
  YYSYMBOL_statereg = 310,                 /* statereg  */
  YYSYMBOL_controlreg = 311,               /* controlreg  */
  YYSYMBOL_ipreg = 312,                    /* ipreg  */
  YYSYMBOL_nullreg = 313,                  /* nullreg  */
  YYSYMBOL_threadcontrolreg = 314,         /* threadcontrolreg  */
  YYSYMBOL_performancereg = 315,           /* performancereg  */
  YYSYMBOL_channelenablereg = 316,         /* channelenablereg  */
  YYSYMBOL_immval = 317,                   /* immval  */
  YYSYMBOL_dstregion = 318,                /* dstregion  */
  YYSYMBOL_indirectregion = 319,           /* indirectregion  */
  YYSYMBOL_region = 320,                   /* region  */
  YYSYMBOL_region_wh = 321,                /* region_wh  */
  YYSYMBOL_reg_type = 322,                 /* reg_type  */
  YYSYMBOL_imm_type = 323,                 /* imm_type  */
  YYSYMBOL_writemask = 324,                /* writemask  */
  YYSYMBOL_writemask_x = 325,              /* writemask_x  */
  YYSYMBOL_writemask_y = 326,              /* writemask_y  */
  YYSYMBOL_writemask_z = 327,              /* writemask_z  */
  YYSYMBOL_writemask_w = 328,              /* writemask_w  */
  YYSYMBOL_swizzle = 329,                  /* swizzle  */
  YYSYMBOL_chansel = 330,                  /* chansel  */
  YYSYMBOL_predicate = 331,                /* predicate  */
  YYSYMBOL_predstate = 332,                /* predstate  */
  YYSYMBOL_predctrl = 333,                 /* predctrl  */
  YYSYMBOL_negate = 334,                   /* negate  */
  YYSYMBOL_abs = 335,                      /* abs  */
  YYSYMBOL_cond_mod = 336,                 /* cond_mod  */
  YYSYMBOL_condModifiers = 337,            /* condModifiers  */
  YYSYMBOL_msgdesc = 338,                  /* msgdesc  */
  YYSYMBOL_msgdesc_parts = 339,            /* msgdesc_parts  */
  YYSYMBOL_saturate = 340,                 /* saturate  */
  YYSYMBOL_execsize = 341,                 /* execsize  */
  YYSYMBOL_instoptions = 342,              /* instoptions  */
  YYSYMBOL_instoption_list = 343,          /* instoption_list  */
  YYSYMBOL_depinfo = 344,                  /* depinfo  */
  YYSYMBOL_instoption = 345                /* instoption  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;



/* Unqualified %code blocks.  */
#line 550 "../src/intel/compiler/brw_gram.y"


static void
add_instruction_option(struct options *options, struct instoption opt)
{
   if (opt.type == INSTOPTION_DEP_INFO) {
      if (opt.depinfo_value.regdist) {
         options->depinfo.regdist = opt.depinfo_value.regdist;
         options->depinfo.pipe = opt.depinfo_value.pipe;
      } else {
         options->depinfo.sbid = opt.depinfo_value.sbid;
         options->depinfo.mode = opt.depinfo_value.mode;
      }
      return;
   }
   if (opt.type == INSTOPTION_CHAN_OFFSET) {
      options->chan_offset = opt.uint_value;
      return;
   }
   switch (opt.uint_value) {
   case ALIGN1:
      options->access_mode = BRW_ALIGN_1;
      break;
   case ALIGN16:
      options->access_mode = BRW_ALIGN_16;
      break;
   case SWITCH:
      options->thread_control |= BRW_THREAD_SWITCH;
      break;
   case ATOMIC:
      options->thread_control |= BRW_THREAD_ATOMIC;
      break;
   case BRANCH_CTRL:
      options->branch_control = true;
      break;
   case NODDCHK:
      options->no_dd_check = true;
      break;
   case NODDCLR:
      options->no_dd_clear = true;
      break;
   case MASK_DISABLE:
      options->mask_control |= BRW_MASK_DISABLE;
      break;
   case BREAKPOINT:
      options->debug_control = BRW_DEBUG_BREAKPOINT;
      break;
   case WECTRL:
      options->mask_control |= BRW_WE_ALL;
      break;
   case CMPTCTRL:
      /* Don't set the compaction flag to true, we're just reading
       * text assembly, not instruction bits. The code that will
       * assemble things later will set the flag if it decides to
       * compact instructions.
       */
      if (!compaction_warning_given) {
         compaction_warning_given = true;
         fprintf(stderr, "%s: ignoring 'compacted' "
                 "annotations for text assembly "
                 "instructions\n", input_filename);
      }
      break;
   case ACCWREN:
      options->acc_wr_control = true;
      break;
   case EOT:
      options->end_of_thread = true;
      break;
   }
}

#line 841 "src/intel/compiler/brw_gram.tab.c"

#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  37
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   806

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  243
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  103
/* YYNRULES -- Number of rules.  */
#define YYNRULES  355
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  583

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   497


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   625,   625,   629,   630,   631,   632,   633,   634,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   652,
     653,   654,   655,   656,   660,   670,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   719,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   764,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   807,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   839,   847,   871,   893,   894,   895,   896,   897,
     898,   899,   904,   923,   938,   953,   987,  1026,  1027,  1031,
    1032,  1033,  1034,  1038,  1042,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1064,  1065,  1069,  1070,  1077,  1078,  1085,  1095,  1111,  1122,
    1134,  1148,  1161,  1174,  1188,  1204,  1221,  1234,  1242,  1267,
    1268,  1269,  1270,  1271,  1272,  1276,  1284,  1289,  1290,  1294,
    1302,  1303,  1307,  1321,  1333,  1342,  1351,  1352,  1353,  1354,
    1355,  1356,  1357,  1358,  1359,  1360,  1361,  1365,  1370,  1379,
    1380,  1384,  1435,  1443,  1447,  1448,  1452,  1453,  1457,  1458,
    1459,  1463,  1464,  1476,  1490,  1497,  1504,  1505,  1506,  1507,
    1508,  1509,  1510,  1514,  1535,  1536,  1537,  1538,  1542,  1556,
    1561,  1567,  1572,  1573,  1577,  1578,  1582,  1592,  1602,  1617,
    1633,  1653,  1666,  1680,  1692,  1709,  1722,  1726,  1730,  1743,
    1762,  1776,  1780,  1789,  1792,  1802,  1803,  1808,  1811,  1818,
    1833,  1847,  1861,  1876,  1877,  1878,  1879,  1880,  1881,  1882,
    1883,  1884,  1885,  1886,  1887,  1891,  1892,  1893,  1894,  1899,
    1902,  1909,  1910,  1914,  1915,  1919,  1920,  1924,  1925,  1930,
    1933,  1937,  1944,  1945,  1946,  1947,  1953,  1959,  1969,  1970,
    1971,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1996,  1997,
    2001,  2002,  2007,  2013,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2038,  2042,  2047,  2052,
    2053,  2055,  2061,  2062,  2067,  2071,  2083,  2086,  2094,  2100,
    2107,  2113,  2119,  2125,  2131,  2137,  2143,  2149,  2155,  2161,
    2167,  2175,  2176,  2177,  2184,  2185,  2186,  2187,  2188,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2205,
    2206,  2212,  2213,  2219,  2220,  2226
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABS", "COLON",
  "COMMA", "DOT", "LANGLE", "RANGLE", "LCURLY", "RCURLY", "LPAREN",
  "RPAREN", "LSQUARE", "RSQUARE", "PLUS", "MINUS", "SEMICOLON", "ASSIGN",
  "TYPE_B", "TYPE_UB", "TYPE_W", "TYPE_UW", "TYPE_D", "TYPE_UD", "TYPE_Q",
  "TYPE_UQ", "TYPE_V", "TYPE_UV", "TYPE_F", "TYPE_HF", "TYPE_BF",
  "TYPE_DF", "TYPE_VF", "JUMP_LABEL", "JUMP_LABEL_TARGET", "JIP", "UIP",
  "ADD", "ADD3", "ADDC", "AND", "ASR", "AVG", "BFE", "BFI1", "BFI2", "BFB",
  "BFREV", "BRC", "BRD", "BREAK", "CALL", "CALLA", "CASE", "CBIT", "CMP",
  "CMPN", "CONT", "CSEL", "DIM", "DO", "DPAS", "DP2", "DP3", "DP4", "DP4A",
  "DPH", "ELSE", "ENDIF", "FBH", "FBL", "FORK", "FRC", "GOTO", "HALT",
  "IF", "ILLEGAL", "JMPI", "JOIN", "LINE", "LRP", "LZD", "MAC", "MACH",
  "MAD", "MADM", "MATH", "MOV", "MOVI", "MUL", "MREST", "MSAVE", "NENOP",
  "NOP", "NOT", "OR", "PLN", "POP", "PUSH", "RET", "RNDD", "RNDE", "RNDU",
  "RNDZ", "ROL", "ROR", "SEL", "SENDS", "SENDSC", "SHL", "SHR", "SMOV",
  "SUBB", "SYNC", "SEND_GFX4", "SENDC_GFX4", "SEND_GFX12", "SENDC_GFX12",
  "WAIT", "WHILE", "XOR", "COS", "EXP", "FDIV", "INV", "INVM", "INTDIV",
  "INTDIVMOD", "INTMOD", "LOG", "POW", "RSQ", "RSQRTM", "SIN", "SINCOS",
  "SQRT", "ALLRD", "ALLWR", "FENCE", "BAR", "HOST", "HDC0", "HDC1", "HDC2",
  "HDC_RO", "GATEWAY", "PIXEL_INTERP", "RENDER", "SAMPLER", "TS_BTD",
  "URB", "RT_ACCEL", "SLM", "TGM", "UGM", "MSGDESC_BEGIN", "SRC1_LEN",
  "EX_BSO", "MSGDESC_END", "EQUAL", "GREATER", "GREATER_EQUAL", "LESS",
  "LESS_EQUAL", "NOT_EQUAL", "NOT_ZERO", "OVERFLOW", "UNORDERED", "ZERO",
  "ALIGN1", "ALIGN16", "ACCWREN", "CMPTCTRL", "WECTRL", "BREAKPOINT",
  "NODDCLR", "NODDCHK", "EOT", "MASK_DISABLE", "ANYV", "ALLV", "ANY2H",
  "ALL2H", "ANY4H", "ALL4H", "ANY8H", "ALL8H", "ANY16H", "ALL16H",
  "ANY32H", "ALL32H", "ROUND_INCREMENT", "SATURATE", "ATOMIC", "SWITCH",
  "BRANCH_CTRL", "QTR_2Q", "QTR_3Q", "QTR_4Q", "QTR_2H", "QTR_2N",
  "QTR_3N", "QTR_4N", "QTR_5N", "QTR_6N", "QTR_7N", "QTR_8N", "X", "Y",
  "Z", "W", "GENREGFILE", "VxH", "GENREG", "ADDRREG", "ACCREG", "FLAGREG",
  "NOTIFYREG", "STATEREG", "CONTROLREG", "IPREG", "PERFORMANCEREG",
  "THREADREG", "CHANNELENABLEREG", "MASKREG", "SCALARREG", "INTEGER",
  "LONG", "NULL_TOKEN", "SUBREGNUM", "EMPTYEXECSIZE", "REG_DIST_CURRENT",
  "REG_DIST_FLOAT", "REG_DIST_INT", "REG_DIST_LONG", "REG_DIST_ALL",
  "REG_DIST_MATH", "REG_DIST_SCALAR", "SBID_ALLOC", "SBID_WAIT_SRC",
  "SBID_WAIT_DST", "DPAS_PARAMS", "$accept", "ROOT", "instrseq",
  "instruction", "relocatableinstruction", "illegalinstruction",
  "unaryinstruction", "unaryopcodes", "binaryinstruction", "binaryopcodes",
  "binaryaccinstruction", "binaryaccopcodes", "mathinstruction",
  "math_function", "nopinstruction", "ternaryinstruction",
  "ternaryopcodes", "waitinstruction", "sendinstruction", "sendop",
  "sendsop", "sendopcode", "sendsopcode", "sharedfunction", "exp2", "desc",
  "ex_desc", "reg32a", "jumpinstruction", "branchinstruction",
  "joininstruction", "breakinstruction", "loopinstruction",
  "syncinstruction", "sync_function", "sync_arg", "relativelocation2",
  "jumplabeltarget", "dst", "dstoperand", "dstoperandex",
  "dstoperandex_typed", "dstreg", "srcaccimm", "immreg", "reg32",
  "payload", "src", "srcacc", "srcimm", "directsrcaccoperand",
  "srcarcoperandex", "srcarcoperandex_typed", "indirectsrcoperand",
  "directgenreg_list", "directsrcoperand", "addrparam", "exp", "subregnum",
  "directgenreg", "indirectgenreg", "addrreg", "accreg", "flagreg",
  "maskreg", "notifyreg", "scalarreg", "statereg", "controlreg", "ipreg",
  "nullreg", "threadcontrolreg", "performancereg", "channelenablereg",
  "immval", "dstregion", "indirectregion", "region", "region_wh",
  "reg_type", "imm_type", "writemask", "writemask_x", "writemask_y",
  "writemask_z", "writemask_w", "swizzle", "chansel", "predicate",
  "predstate", "predctrl", "negate", "abs", "cond_mod", "condModifiers",
  "msgdesc", "msgdesc_parts", "saturate", "execsize", "instoptions",
  "instoption_list", "depinfo", "instoption", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-480)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      50,    48,  -480,     6,     6,     6,  -480,     6,    26,    18,
      20,    29,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   583,  -480,
    -480,  -158,   -10,    73,    54,    73,   531,  -480,    96,    99,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,     6,  -480,  -480,  -480,     6,  -480,  -480,
    -108,  -480,  -480,  -480,  -480,  -480,     6,  -480,  -480,  -480,
       6,     6,     6,     6,     6,  -480,  -480,  -480,  -480,  -480,
    -480,   -47,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   173,
    -480,  -480,  -480,  -480,     6,  -480,   -47,   -47,   -47,   -47,
    -480,  -480,     6,     6,   132,   348,   -86,  -480,   137,  -480,
    -480,   122,  -480,   144,   132,   132,   132,   132,   132,   132,
    -480,   132,   132,   132,   132,   132,  -480,    73,  -480,  -480,
     151,   151,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,   151,  -480,  -480,  -480,  -480,  -480,   127,
     131,   -47,   138,   139,   140,   143,     3,   146,  -480,   655,
    -480,  -480,  -480,  -480,  -480,  -480,     6,   148,   427,   427,
     427,   427,   531,   531,   -87,  -480,    81,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   152,
    -480,  -480,   377,   149,   -30,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,   -87,   174,   174,
     174,   157,   158,   427,   162,   169,   170,   172,   -10,  -480,
      73,  -480,  -480,   203,   773,   178,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,     6,    22,   179,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,     6,   210,     6,     6,     6,
     290,    59,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
     535,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   187,   209,
     -87,   217,    25,   696,   696,   696,   189,   197,     6,    73,
     200,   201,   205,   235,  -480,  -177,   696,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,    73,   531,    73,  -480,   203,    73,
     531,  -158,   531,   531,   531,  -480,   261,  -480,   203,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,   203,  -480,  -480,   241,
     239,   290,  -480,    73,  -480,  -480,  -480,  -480,    38,  -480,
    -480,  -480,   214,   224,   531,  -480,   229,   236,   238,   -10,
     263,    57,  -480,  -480,   290,  -480,   696,  -480,    36,  -480,
      36,   290,    36,   -86,   415,   -10,   696,   696,  -480,   234,
      43,   -14,  -480,  -480,    64,    73,    73,   290,    73,    73,
      73,   268,   -87,   -87,  -480,   -87,    36,  -480,  -480,   241,
    -480,    73,  -480,  -480,  -480,  -480,  -480,   241,  -480,    36,
    -480,  -480,    36,   290,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   145,
     415,  -480,  -480,   203,  -480,  -480,  -480,  -480,   273,  -480,
     -14,  -480,   203,  -480,    82,  -480,  -480,   290,  -480,  -480,
    -480,   -10,   300,   303,   304,    73,   221,  -480,   216,    73,
      73,    36,    -3,    73,   145,   314,   -14,  -480,   415,  -480,
     696,  -480,  -480,   290,   317,   -87,   -87,   -87,  -480,   318,
     203,  -480,  -480,    73,    -3,   308,    -3,    -3,   168,  -480,
      73,   107,   696,   -14,   145,  -480,    73,   -10,   321,   327,
     328,  -177,   314,  -480,  -480,   696,  -480,  -480,   119,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,   107,  -480,   415,
      73,  -480,   333,  -480,  -480,  -480,   128,   696,  -480,    -3,
     107,   145,  -480,  -480,   -87,  -480,  -480,   107,    73,    92,
    -480,  -480,  -480
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     266,   268,   149,   314,   314,   314,    82,   314,     0,   266,
       0,     0,    17,     9,    10,    11,    12,    13,    15,    14,
      16,    19,    20,    23,    21,    22,    18,     8,     0,   269,
     270,     0,     0,   316,     0,   316,     0,     1,     0,     0,
       7,     5,     6,    55,    91,    40,    56,    57,    58,    86,
      41,    87,    26,   314,    27,    59,    60,   314,    85,    28,
       0,    42,    43,    44,    90,    45,   314,    29,    30,    31,
     314,   314,   314,   314,   314,    46,    88,    32,    47,    48,
      89,   312,    33,    49,    34,    61,    50,    35,    36,    37,
      38,    51,    52,    62,   101,   102,    63,    64,    53,     0,
      97,    98,    99,   100,   314,    65,   312,   312,   312,   312,
     103,   104,   314,   314,   205,   271,     0,   120,     0,   320,
     137,     0,    24,     0,   205,   205,   205,   205,   205,   205,
     216,   205,   205,   205,   205,   205,   217,   316,   150,   151,
     223,   223,   167,   168,   157,   156,   160,   162,   163,   166,
     165,   159,   161,   223,   155,   164,   158,     3,     4,     0,
       0,   312,     0,     0,     0,     0,     0,     0,   313,     0,
     139,   140,   141,   142,   143,   144,   314,     0,   294,   294,
     294,   294,     0,     0,     0,   210,     0,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,     0,
     121,   315,     0,     0,     0,   206,   208,   209,   212,   214,
     215,   219,   218,   220,   211,   213,    92,     0,   249,   249,
     249,     0,     0,   294,     0,     0,     0,     0,     0,   221,
     316,   147,   148,   227,     0,     0,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    81,
      80,   314,     0,     0,   296,   299,   300,   301,   302,   298,
     297,   303,   305,   295,   304,   314,   292,   314,   314,   314,
     288,   288,   202,   203,   204,   272,   273,   274,   275,   267,
       0,   317,   331,   332,   333,   342,   343,   334,   335,   336,
     338,   337,   340,   339,   341,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   355,   319,     0,     0,
     201,     0,   251,     0,     0,     0,     0,     0,   314,   316,
       0,     0,     0,     0,   127,     0,     0,   239,   238,   237,
     236,   235,   234,   242,   241,   246,   248,   233,   243,   244,
     240,   247,   245,   171,   316,     0,   316,   146,   227,   316,
       0,     0,     0,     0,     0,   289,   288,   199,   227,   173,
     188,   190,   192,   191,   187,   189,   227,   185,   186,   290,
       0,   288,   318,   316,   207,   200,   224,   252,   253,   153,
     152,   154,     0,     0,     0,   128,     0,     0,     0,     0,
       0,     0,   172,   132,   288,   138,     0,   136,   288,   293,
     288,   288,   288,   289,     0,     0,     0,     0,   291,     0,
       0,     0,   129,   254,   255,   316,   316,   288,   316,   316,
     316,     0,     0,     0,   228,     0,   288,   175,   174,   290,
     145,   316,   170,   169,   176,   177,   181,   290,   180,   288,
     179,   178,   288,   288,   111,   113,   115,   110,   106,   112,
     109,   114,   108,   107,   116,   117,   118,   119,   105,     0,
       0,   183,   184,   227,   194,   196,   195,   197,     0,   123,
       0,   122,   227,   256,   257,   133,   135,   288,   131,   134,
     130,     0,     0,     0,     0,   316,     0,    25,     0,   316,
     316,   288,   311,   316,     0,   259,     0,   125,     0,   124,
       0,   258,   250,   288,     0,     0,     0,     0,    66,   227,
     227,    39,    54,   316,   311,     0,   311,   311,     0,    93,
     316,     0,     0,     0,     0,   126,   316,     0,     0,     0,
       0,     0,   259,   225,   226,     0,    83,   310,     0,   308,
     309,   306,    94,   262,   263,   264,   265,   260,   198,     0,
     316,    84,     0,   231,   229,   230,     0,     0,   182,   311,
       0,     0,    95,   222,     0,   193,   307,     0,   316,     0,
     261,    96,   232
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -480,  -480,  -480,   347,   352,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -463,   -29,  -142,  -157,  -456,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,   368,  -155,  -480,
    -480,  -480,  -480,  -480,  -165,  -480,  -251,  -419,   -27,  -382,
    -480,  -480,  -480,    -8,  -480,  -238,  -480,  -137,   473,  -153,
    -367,  -199,  -117,   -22,    -5,  -376,   -32,     5,    11,    47,
     -11,    53,  -375,    63,  -480,   -93,  -480,  -292,  -480,  -313,
    -480,   -67,  -480,  -480,  -480,  -480,  -145,  -479,  -480,  -480,
    -480,  -249,  -366,   -55,  -480,  -369,  -455,   -51,    35,   -35,
    -480,  -480,   105
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     8,     9,    10,    11,    12,    13,   106,    14,   107,
      15,   108,    16,   251,    17,    18,   109,    19,    20,   110,
     111,   112,   113,   469,   229,   480,   508,   481,    21,    22,
      23,    24,    25,    26,   176,   356,   230,    27,   137,   138,
     139,   140,   141,   441,   448,   232,   366,   436,   443,   449,
     444,   367,   368,   450,   473,   451,   319,   274,   185,   142,
     143,   144,   145,   370,   371,   148,   372,   373,   374,   375,
     376,   377,   155,   378,   234,   218,   542,   336,   544,   352,
     353,   323,   388,   424,   484,   512,   532,   557,    28,    31,
     199,   439,   419,   265,   266,   503,   528,   169,    33,   120,
     202,   316,   317
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     122,   231,   116,   118,   149,   320,   116,   504,   487,   115,
     389,   390,   391,   233,   146,   524,   228,    32,    -2,   116,
     381,   379,   379,   402,   509,   153,    37,   270,   271,     1,
     453,   147,   369,   369,   501,   228,   400,    41,   116,    34,
      35,   150,    36,   476,   477,   534,    42,   151,   219,   228,
     272,   273,   413,     2,   495,   178,   179,   180,   181,   114,
     220,     1,   433,    29,    30,   434,   406,   499,   513,   547,
     500,   549,   550,   496,   435,   365,   416,   509,   570,     3,
     321,   498,   119,   152,   417,     2,     4,   357,   159,   154,
     121,   577,   160,   440,   536,     5,   571,   516,   580,   156,
     582,   162,   216,   471,   472,   163,   164,   165,   166,   167,
     223,     3,     6,   157,   576,   415,   158,   379,     4,   523,
     476,   477,   476,   477,   267,   268,   269,     5,   369,   519,
     421,   519,   379,   574,   161,   530,   434,     7,   184,   177,
     272,   273,   200,   369,     6,   435,   168,   182,   183,   201,
     149,   149,   324,   325,   525,   526,   203,   204,   217,   447,
     146,   146,   447,   221,   279,   560,   438,   222,   328,     7,
     446,   153,   153,   446,   224,   225,   226,   147,   147,   227,
     322,   505,   235,   385,   253,   125,   318,   150,   150,   438,
     510,   326,   327,   151,   151,   334,   329,   535,   401,   333,
     404,   125,   578,   330,   331,   408,   332,   410,   411,   412,
     335,   252,   354,   359,   117,   438,   361,   124,   117,   558,
     475,   383,   482,   384,   527,   386,   392,   543,   545,   152,
     152,   117,   568,   387,   393,   154,   154,   396,   397,   427,
     399,   358,   398,   442,   418,   156,   156,   423,   425,   438,
     117,   136,   420,   114,   575,   128,   129,   130,   426,   132,
     133,   134,   135,   428,   117,   136,   474,   170,   432,   135,
     429,   380,   430,   491,   483,   438,   114,   413,   128,   129,
     130,   482,   132,   133,   134,   135,   355,   506,   136,   275,
     276,   277,   278,   511,   395,   492,   493,   475,   494,   475,
     360,   502,   362,   363,   364,   515,   365,   482,   516,   517,
     171,   172,   173,   174,   175,   553,   554,   555,   556,   403,
     531,   405,   537,   149,   407,   541,   548,   551,   149,   563,
     149,   149,   149,   146,   482,   564,   565,   414,   146,   409,
     146,   146,   146,   474,   153,   474,   569,   573,   422,   153,
     147,   153,   153,   153,   186,   147,    38,   147,   147,   147,
     150,    39,   149,   394,   533,   150,   151,   150,   150,   150,
     431,   151,   146,   151,   151,   151,   559,    40,   538,   539,
     540,   520,   280,   153,   452,   382,   470,   281,   478,   147,
     485,   486,   479,   488,   489,   490,   437,   567,     0,   150,
     445,     0,   152,   445,   566,   151,   497,   152,   154,   152,
     152,   152,     0,   154,     0,   154,   154,   154,   156,   437,
       0,     0,     0,   156,     0,   156,   156,   156,   123,     0,
     124,   125,   126,   123,   127,   124,   125,   579,   131,   127,
       0,   152,     0,   131,     0,   437,     0,   154,   124,   125,
       0,   507,   127,     0,     0,     0,   131,   156,     0,     0,
     518,     0,   514,     0,   521,   522,     0,     0,   529,     0,
       0,     0,     0,     0,     0,     0,     0,   479,   114,   437,
     128,   129,   130,     0,   132,   133,   134,   135,   546,   117,
     136,     0,     0,     0,     0,   552,     0,     0,     0,     0,
       0,   561,     0,     0,   507,   437,     0,   114,   562,   128,
     129,   130,     0,   132,   133,   134,   135,     0,     0,   136,
       0,     0,     0,     0,     0,   572,     0,     0,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
       0,     0,     0,   581,     0,     0,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,     0,     0,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   205,   206,   207,
     208,   209,   210,     0,   211,   212,   213,   214,   215,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   264,
       0,    43,    44,    45,    46,    47,    48,    49,    50,    51,
       0,    52,     0,     0,    53,     0,     0,     0,    54,    55,
      56,    57,    58,    59,   468,    60,    61,    62,    63,    64,
      65,     0,    66,    67,    68,     0,    69,    70,    71,    72,
       0,    73,    74,    75,    76,    77,    78,    79,    80,     0,
      81,    82,     0,    83,     0,     0,     0,     0,    84,    85,
      86,     0,     0,     0,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   337,   338,   339,   340,   341,
     342,   343,   344,     0,     0,   347,   348,   349,   350,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   123,     0,   124,   125,   126,   114,   127,
     128,   129,   130,   131,   132,   133,   134,   135,     0,     0,
     136,     0,     0,     0,     0,     0,     0,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351
};

static const yytype_int16 yycheck[] =
{
      35,   166,    16,    32,    36,   204,    16,   470,   427,    31,
     323,   324,   325,   166,    36,    18,    13,    11,     0,    16,
     271,   270,   271,   336,   480,    36,     0,   182,   183,    11,
     412,    36,   270,   271,   453,    13,   213,    17,    16,     4,
       5,    36,     7,   419,   419,   508,    17,    36,   141,    13,
     227,   228,    16,    35,   436,   106,   107,   108,   109,   217,
     153,    11,     5,    15,    16,     8,   358,   449,   487,   524,
     452,   526,   527,   439,    17,    16,   368,   533,   557,    61,
     217,   447,     9,    36,   376,    35,    68,   252,    53,    36,
      36,   570,    57,   406,   513,    77,   559,     5,   577,    36,
       8,    66,   137,   416,   417,    70,    71,    72,    73,    74,
     161,    61,    94,    17,   569,   366,    17,   366,    68,   501,
     496,   496,   498,   498,   179,   180,   181,    77,   366,   496,
     381,   498,   381,     5,   242,   504,     8,   119,     6,   104,
     227,   228,   228,   381,    94,    17,   193,   112,   113,    12,
     182,   183,   219,   220,   157,   158,    34,    13,     7,   408,
     182,   183,   411,    36,    12,   534,   404,    36,   223,   119,
     408,   182,   183,   411,    36,    36,    36,   182,   183,    36,
       6,   473,    36,   320,    36,   215,    37,   182,   183,   427,
     482,    34,    34,   182,   183,   230,    34,   510,   335,   228,
     355,   215,   571,    34,    34,   360,    34,   362,   363,   364,
       7,   176,    34,    34,   228,   453,     6,   214,   228,   532,
     419,    34,   421,    14,   227,     8,    37,   519,   520,   182,
     183,   228,   545,   208,    37,   182,   183,    37,    37,   394,
       5,   252,    37,   408,     3,   182,   183,   209,    34,   487,
     228,   229,    13,   217,   567,   219,   220,   221,    34,   223,
     224,   225,   226,    34,   228,   229,   419,    94,     5,   226,
      34,   212,    34,     5,   210,   513,   217,    16,   219,   220,
     221,   480,   223,   224,   225,   226,   251,    14,   229,   208,
     209,   210,   211,   211,   329,   432,   433,   496,   435,   498,
     265,   156,   267,   268,   269,     5,    16,   506,     5,     5,
     137,   138,   139,   140,   141,   208,   209,   210,   211,   354,
       6,   356,     5,   355,   359,     7,    18,   159,   360,     8,
     362,   363,   364,   355,   533,     8,     8,   366,   360,   361,
     362,   363,   364,   496,   355,   498,   227,    14,   383,   360,
     355,   362,   363,   364,     6,   360,     9,   362,   363,   364,
     355,     9,   394,   328,   506,   360,   355,   362,   363,   364,
     399,   360,   394,   362,   363,   364,   533,     9,   515,   516,
     517,   498,     5,   394,   411,   280,   415,    10,   420,   394,
     425,   426,   421,   428,   429,   430,   404,   542,    -1,   394,
     408,    -1,   355,   411,   541,   394,   441,   360,   355,   362,
     363,   364,    -1,   360,    -1,   362,   363,   364,   355,   427,
      -1,    -1,    -1,   360,    -1,   362,   363,   364,   212,    -1,
     214,   215,   216,   212,   218,   214,   215,   574,   222,   218,
      -1,   394,    -1,   222,    -1,   453,    -1,   394,   214,   215,
      -1,   480,   218,    -1,    -1,    -1,   222,   394,    -1,    -1,
     495,    -1,   491,    -1,   499,   500,    -1,    -1,   503,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   217,   487,
     219,   220,   221,    -1,   223,   224,   225,   226,   523,   228,
     229,    -1,    -1,    -1,    -1,   530,    -1,    -1,    -1,    -1,
      -1,   536,    -1,    -1,   533,   513,    -1,   217,   537,   219,
     220,   221,    -1,   223,   224,   225,   226,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,   560,    -1,    -1,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
      -1,    -1,    -1,   578,    -1,    -1,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,    -1,    -1,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,   135,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   192,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    -1,    -1,    51,    -1,    -1,    -1,    55,    56,
      57,    58,    59,    60,   229,    62,    63,    64,    65,    66,
      67,    -1,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    -1,    90,    -1,    -1,    -1,    -1,    95,    96,
      97,    -1,    -1,    -1,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,   121,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    29,    30,    31,    32,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   212,    -1,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,    -1,    -1,    -1,    -1,    -1,    -1,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    11,    35,    61,    68,    77,    94,   119,   244,   245,
     246,   247,   248,   249,   251,   253,   255,   257,   258,   260,
     261,   271,   272,   273,   274,   275,   276,   280,   331,    15,
      16,   332,    11,   341,   341,   341,   341,     0,   246,   247,
     280,    17,    17,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    48,    51,    55,    56,    57,    58,    59,    60,
      62,    63,    64,    65,    66,    67,    69,    70,    71,    73,
      74,    75,    76,    78,    79,    80,    81,    82,    83,    84,
      85,    87,    88,    90,    95,    96,    97,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   113,   114,
     115,   116,   117,   118,   120,   121,   250,   252,   254,   259,
     262,   263,   264,   265,   217,   306,    16,   228,   267,     9,
     342,    36,   342,   212,   214,   215,   216,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   229,   281,   282,   283,
     284,   285,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,    17,    17,   341,
     341,   242,   341,   341,   341,   341,   341,   341,   193,   340,
      94,   137,   138,   139,   140,   141,   277,   341,   340,   340,
     340,   340,   341,   341,     6,   301,     6,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   333,
     228,    12,   343,    34,    13,   301,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   342,     7,   318,   318,
     318,    36,    36,   340,    36,    36,    36,    36,    13,   267,
     279,   287,   288,   302,   317,    36,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   256,   341,    36,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   192,   336,   337,   336,   336,   336,
     281,   281,   227,   228,   300,   208,   209,   210,   211,    12,
       5,    10,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   344,   345,    37,   299,
     304,   300,     6,   324,   324,   324,    34,    34,   336,    34,
      34,    34,    34,   267,   342,     7,   320,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,   322,   323,    34,   341,   278,   287,   313,    34,
     341,     6,   341,   341,   341,    16,   289,   294,   295,   298,
     306,   307,   309,   310,   311,   312,   313,   314,   316,   334,
     212,   289,   345,    34,    14,   300,     8,   208,   325,   322,
     322,   322,    37,    37,   341,   342,    37,    37,    37,     5,
     213,   300,   322,   342,   281,   342,   320,   342,   281,   306,
     281,   281,   281,    16,   267,   289,   320,   320,     3,   335,
      13,   289,   342,   209,   326,    34,    34,   281,    34,    34,
      34,   267,     5,     5,     8,    17,   290,   296,   298,   334,
     322,   286,   287,   291,   293,   296,   298,   334,   287,   292,
     296,   298,   291,   292,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   229,   266,
     267,   322,   322,   297,   302,   304,   308,   315,   309,   267,
     268,   270,   304,   210,   327,   342,   342,   290,   342,   342,
     342,     5,   300,   300,   300,   292,   335,   342,   335,   292,
     292,   290,   156,   338,   266,   320,    14,   267,   269,   270,
     320,   211,   328,   290,   267,     5,     5,     5,   342,   303,
     305,   342,   342,   292,    18,   157,   158,   227,   339,   342,
     338,     6,   329,   268,   266,   322,   290,     5,   300,   300,
     300,     7,   319,   320,   321,   320,   342,   339,    18,   339,
     339,   159,   342,   208,   209,   210,   211,   330,   322,   269,
     338,   342,   267,     8,     8,     8,   300,   329,   322,   227,
     330,   266,   342,    14,     5,   322,   339,   330,   338,   300,
     330,   342,     8
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   243,   244,   245,   245,   245,   245,   245,   245,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   247,
     247,   247,   247,   247,   248,   249,   250,   250,   250,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   251,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   253,   254,   254,   254,   254,   254,
     254,   254,   254,   254,   254,   254,   255,   256,   256,   256,
     256,   256,   256,   256,   256,   256,   256,   256,   256,   256,
     256,   256,   257,   258,   258,   259,   259,   259,   259,   259,
     259,   259,   260,   261,   261,   261,   261,   262,   262,   263,
     263,   263,   263,   264,   265,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     267,   267,   268,   268,   269,   269,   270,   271,   272,   272,
     272,   272,   273,   274,   274,   274,   275,   275,   276,   277,
     277,   277,   277,   277,   277,   278,   278,   279,   279,   280,
     281,   281,   282,   283,   283,   283,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   285,   285,   286,
     286,   287,   288,   289,   290,   290,   291,   291,   292,   292,
     292,   293,   293,   294,   294,   294,   295,   295,   295,   295,
     295,   295,   295,   296,   297,   297,   297,   297,   298,   298,
     299,   299,   300,   300,   301,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   317,   318,   318,   319,   319,   320,   320,   320,
     320,   320,   321,   322,   322,   322,   322,   322,   322,   322,
     322,   322,   322,   322,   322,   323,   323,   323,   323,   324,
     324,   325,   325,   326,   326,   327,   327,   328,   328,   329,
     329,   329,   330,   330,   330,   330,   331,   331,   332,   332,
     332,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   333,   333,   334,   334,
     335,   335,   336,   336,   337,   337,   337,   337,   337,   337,
     337,   337,   337,   337,   337,   337,   338,   339,   339,   339,
     339,   339,   340,   340,   341,   341,   342,   342,   343,   343,
     343,   344,   344,   344,   344,   344,   344,   344,   344,   344,
     344,   345,   345,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345,   345,   345,   345,   345,
     345,   345,   345,   345,   345,   345
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     3,     3,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     8,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     9,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     9,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     9,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,    10,    11,     1,     1,     1,     1,     1,
       1,     1,     4,     9,    10,    11,    13,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     3,     5,     6,     7,
       8,     8,     6,     8,     8,     8,     6,     3,     6,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     4,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     5,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     1,     1,     1,     1,     6,     1,
       2,     1,     1,     1,     2,     0,     2,     4,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     2,     2,
       2,     1,     9,     0,     3,     1,     1,     0,     3,     7,
       7,     7,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       5,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       2,     5,     1,     1,     1,     1,     0,     5,     0,     1,
       1,     0,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       0,     1,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     4,     2,     2,
       2,     0,     0,     1,     0,     3,     0,     3,     3,     2,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 24: /* illegalinstruction: ILLEGAL execsize instoptions  */
#line 661 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-2].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-1].integer));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
   }
#line 2440 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 25: /* unaryinstruction: predicate unaryopcodes saturate cond_mod execsize dst srcaccimm instoptions  */
#line 671 "../src/intel/compiler/brw_gram.y"
   {
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      i965_asm_unary_instruction((yyvsp[-6].integer), p, (yyvsp[-2].reg), (yyvsp[-1].reg));
      brw_pop_insn_state(p);
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      if ((yyvsp[-4].condition).cond_modifier) {
         brw_eu_inst_set_cond_modifier(p->devinfo,
                                       brw_last_inst,
                                       (yyvsp[-4].condition).cond_modifier);
      }

      if (!brw_eu_inst_flag_reg_nr(p->devinfo, brw_last_inst)) {
         brw_eu_inst_set_flag_reg_nr(p->devinfo,
                                     brw_last_inst,
                                     (yyvsp[-4].condition).flag_reg_nr);
         brw_eu_inst_set_flag_subreg_nr(p->devinfo,
                                        brw_last_inst,
                                        (yyvsp[-4].condition).flag_subreg_nr);
      }

      if ((yyvsp[-1].reg).file != IMM) {
         brw_eu_inst_set_src0_vstride(p->devinfo, brw_last_inst,
                                      (yyvsp[-1].reg).vstride);
      }
      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-5].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-3].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);
   }
#line 2473 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 39: /* binaryinstruction: predicate binaryopcodes saturate cond_mod execsize dst srcimm srcimm instoptions  */
#line 720 "../src/intel/compiler/brw_gram.y"
   {
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      i965_asm_binary_instruction((yyvsp[-7].integer), p, (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      if ((yyvsp[-5].condition).cond_modifier) {
         brw_eu_inst_set_cond_modifier(p->devinfo,
                                       brw_last_inst,
                                       (yyvsp[-5].condition).cond_modifier);
      }

      if (!brw_eu_inst_flag_reg_nr(p->devinfo, brw_last_inst)) {
         brw_eu_inst_set_flag_reg_nr(p->devinfo, brw_last_inst,
                                     (yyvsp[-5].condition).flag_reg_nr);
         brw_eu_inst_set_flag_subreg_nr(p->devinfo, brw_last_inst,
                                        (yyvsp[-5].condition).flag_subreg_nr);
      }

      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-6].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-4].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      brw_pop_insn_state(p);
   }
#line 2501 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 54: /* binaryaccinstruction: predicate binaryaccopcodes saturate cond_mod execsize dst srcacc srcimm instoptions  */
#line 765 "../src/intel/compiler/brw_gram.y"
   {
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      i965_asm_binary_instruction((yyvsp[-7].integer), p, (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
      brw_pop_insn_state(p);
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      if ((yyvsp[-5].condition).cond_modifier) {
         brw_eu_inst_set_cond_modifier(p->devinfo,
                                       brw_last_inst,
                                       (yyvsp[-5].condition).cond_modifier);
      }

      if (!brw_eu_inst_flag_reg_nr(p->devinfo, brw_last_inst)) {
         brw_eu_inst_set_flag_reg_nr(p->devinfo,
                                     brw_last_inst,
                                     (yyvsp[-5].condition).flag_reg_nr);
         brw_eu_inst_set_flag_subreg_nr(p->devinfo,
                                        brw_last_inst,
                                        (yyvsp[-5].condition).flag_subreg_nr);
      }

      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-6].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-4].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);
   }
#line 2530 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 66: /* mathinstruction: predicate MATH saturate math_function execsize dst src srcimm instoptions  */
#line 808 "../src/intel/compiler/brw_gram.y"
   {
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      gfx6_math(p, (yyvsp[-3].reg), (yyvsp[-5].integer), (yyvsp[-2].reg), (yyvsp[-1].reg));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-4].integer));
      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-6].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);
      brw_pop_insn_state(p);
   }
#line 2544 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 82: /* nopinstruction: NOP  */
#line 840 "../src/intel/compiler/brw_gram.y"
   {
      brw_NOP(p);
   }
#line 2552 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 83: /* ternaryinstruction: predicate ternaryopcodes saturate cond_mod execsize dst srcimm src srcimm instoptions  */
#line 848 "../src/intel/compiler/brw_gram.y"
   {
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      i965_asm_ternary_instruction((yyvsp[-8].integer), p, (yyvsp[-4].reg), (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
      brw_pop_insn_state(p);
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      if ((yyvsp[-6].condition).cond_modifier) {
         brw_eu_inst_set_cond_modifier(p->devinfo,
                                       brw_last_inst,
                                       (yyvsp[-6].condition).cond_modifier);
      }

      if (p->devinfo->ver < 12) {
         brw_eu_inst_set_3src_a16_flag_reg_nr(p->devinfo, brw_last_inst,
                                              (yyvsp[-6].condition).flag_reg_nr);
         brw_eu_inst_set_3src_a16_flag_subreg_nr(p->devinfo, brw_last_inst,
                                                 (yyvsp[-6].condition).flag_subreg_nr);
      }

      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-7].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);
   }
#line 2579 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 84: /* ternaryinstruction: predicate DPAS DPAS_PARAMS saturate cond_mod execsize dst src src src instoptions  */
#line 872 "../src/intel/compiler/brw_gram.y"
   {
      assert(p->devinfo->verx10 >= 125);

      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);

      brw_DPAS(p, translate_systolic_depth((yyvsp[-8].dpas_params).sdepth), (yyvsp[-8].dpas_params).rcount, (yyvsp[-4].reg), (yyvsp[-3].reg), (yyvsp[-2].reg), (yyvsp[-1].reg));
      brw_pop_insn_state(p);
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      if ((yyvsp[-6].condition).cond_modifier) {
         brw_eu_inst_set_cond_modifier(p->devinfo,
                                       brw_last_inst,
                                       (yyvsp[-6].condition).cond_modifier);
      }

      brw_eu_inst_set_saturate(p->devinfo, brw_last_inst, (yyvsp[-7].integer));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);
   }
#line 2602 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 92: /* waitinstruction: WAIT execsize dst instoptions  */
#line 905 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-3].integer));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      struct brw_reg dest = (yyvsp[-1].reg);
      dest.swizzle = brw_swizzle_for_mask(dest.writemask);
      if (dest.file != ARF || dest.nr != BRW_ARF_NOTIFICATION_COUNT)
         error(&(yylsp[-3]), "WAIT must use the notification register\n");
      brw_set_dest(p, brw_last_inst, dest);
      brw_set_src0(p, brw_last_inst, dest);
      brw_set_src1(p, brw_last_inst, brw_null_reg());
      brw_eu_inst_set_mask_control(p->devinfo, brw_last_inst, BRW_MASK_DISABLE);
   }
#line 2621 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 93: /* sendinstruction: predicate sendopcode execsize dst payload exp2 sharedfunction msgdesc instoptions  */
#line 924 "../src/intel/compiler/brw_gram.y"
   {
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-6].integer));
      brw_set_dest(p, brw_last_inst, (yyvsp[-5].reg));
      brw_set_src0(p, brw_last_inst, (yyvsp[-4].reg));
      brw_eu_inst_set_bits(brw_last_inst, 127, 96, (yyvsp[-3].llint));
      brw_eu_inst_set_src1_file_type(p->devinfo, brw_last_inst,
                                     IMM, BRW_TYPE_UD);
      brw_eu_inst_set_sfid(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_eu_inst_set_eot(p->devinfo, brw_last_inst, (yyvsp[0].options).end_of_thread);
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      brw_pop_insn_state(p);
   }
#line 2640 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 94: /* sendinstruction: predicate sendopcode execsize dst payload payload exp2 sharedfunction msgdesc instoptions  */
#line 939 "../src/intel/compiler/brw_gram.y"
   {
      assert(p->devinfo->ver < 12);

      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-7].integer));
      brw_set_dest(p, brw_last_inst, (yyvsp[-6].reg));
      brw_set_src0(p, brw_last_inst, (yyvsp[-5].reg));
      brw_eu_inst_set_bits(brw_last_inst, 127, 96, (yyvsp[-3].llint));
      brw_eu_inst_set_sfid(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_eu_inst_set_eot(p->devinfo, brw_last_inst, (yyvsp[0].options).end_of_thread);
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      brw_pop_insn_state(p);
   }
#line 2659 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 95: /* sendinstruction: predicate sendsopcode execsize dst payload payload desc ex_desc sharedfunction msgdesc instoptions  */
#line 954 "../src/intel/compiler/brw_gram.y"
   {
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-8].integer));
      brw_set_dest(p, brw_last_inst, (yyvsp[-7].reg));
      brw_set_src0(p, brw_last_inst, (yyvsp[-6].reg));
      brw_set_src1(p, brw_last_inst, (yyvsp[-5].reg));

      if ((yyvsp[-4].reg).file == IMM) {
         brw_eu_inst_set_send_sel_reg32_desc(p->devinfo, brw_last_inst, 0);
         brw_eu_inst_set_send_desc(p->devinfo, brw_last_inst, (yyvsp[-4].reg).ud);
      } else {
         brw_eu_inst_set_send_sel_reg32_desc(p->devinfo, brw_last_inst, 1);
      }

      if ((yyvsp[-3].reg).file == IMM) {
         brw_eu_inst_set_send_sel_reg32_ex_desc(p->devinfo, brw_last_inst, 0);
         brw_eu_inst_set_sends_ex_desc(p->devinfo, brw_last_inst, (yyvsp[-3].reg).ud, false);
      } else {
         brw_eu_inst_set_send_sel_reg32_ex_desc(p->devinfo, brw_last_inst, 1);
         brw_eu_inst_set_send_ex_desc_ia_subreg_nr(p->devinfo, brw_last_inst, (yyvsp[-3].reg).subnr >> 2);
      }

      brw_eu_inst_set_sfid(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_eu_inst_set_eot(p->devinfo, brw_last_inst, (yyvsp[0].options).end_of_thread);
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      if (p->devinfo->verx10 >= 125 && (yyvsp[-1].msgdesc).ex_bso) {
         brw_eu_inst_set_send_ex_bso(p->devinfo, brw_last_inst, 1);
         brw_eu_inst_set_send_src1_len(p->devinfo, brw_last_inst, (yyvsp[-1].msgdesc).src1_len);
      }

      brw_pop_insn_state(p);
   }
#line 2697 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 96: /* sendinstruction: predicate sendsopcode execsize dst GENREGFILE LSQUARE scalarreg RSQUARE desc ex_desc sharedfunction msgdesc instoptions  */
#line 988 "../src/intel/compiler/brw_gram.y"
   {
                assert(p->devinfo->ver >= 30);

      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-10].integer));
      brw_set_dest(p, brw_last_inst, (yyvsp[-9].reg));
      brw_set_src0(p, brw_last_inst, (yyvsp[-6].reg));
      brw_set_src1(p, brw_last_inst, brw_null_reg());

      if ((yyvsp[-4].reg).file == IMM) {
         brw_eu_inst_set_send_sel_reg32_desc(p->devinfo, brw_last_inst, 0);
         brw_eu_inst_set_send_desc(p->devinfo, brw_last_inst, (yyvsp[-4].reg).ud);
      } else {
         brw_eu_inst_set_send_sel_reg32_desc(p->devinfo, brw_last_inst, 1);
      }

      if ((yyvsp[-3].reg).file == IMM) {
         brw_eu_inst_set_send_sel_reg32_ex_desc(p->devinfo, brw_last_inst, 0);
         brw_eu_inst_set_sends_ex_desc(p->devinfo, brw_last_inst, (yyvsp[-3].reg).ud, true);
      } else {
         brw_eu_inst_set_send_sel_reg32_ex_desc(p->devinfo, brw_last_inst, 1);
         brw_eu_inst_set_send_ex_desc_ia_subreg_nr(p->devinfo, brw_last_inst, (yyvsp[-3].reg).subnr >> 2);
      }

      brw_eu_inst_set_sfid(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_eu_inst_set_eot(p->devinfo, brw_last_inst, (yyvsp[0].options).end_of_thread);
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      if ((yyvsp[-1].msgdesc).ex_bso) {
         brw_eu_inst_set_send_ex_bso(p->devinfo, brw_last_inst, 1);
         /* Not settings src1 length, as its implied zero. */
      }

      brw_pop_insn_state(p);
   }
#line 2737 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 103: /* sendopcode: sendop  */
#line 1038 "../src/intel/compiler/brw_gram.y"
            { (yyval.instruction) = brw_next_insn(p, (yyvsp[0].integer)); }
#line 2743 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 104: /* sendsopcode: sendsop  */
#line 1042 "../src/intel/compiler/brw_gram.y"
            { (yyval.instruction) = brw_next_insn(p, (yyvsp[0].integer)); }
#line 2749 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 105: /* sharedfunction: NULL_TOKEN  */
#line 1046 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_NULL; }
#line 2755 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 106: /* sharedfunction: GATEWAY  */
#line 1047 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_MESSAGE_GATEWAY; }
#line 2761 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 107: /* sharedfunction: URB  */
#line 1048 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_URB; }
#line 2767 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 108: /* sharedfunction: TS_BTD  */
#line 1049 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_BINDLESS_THREAD_DISPATCH; }
#line 2773 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 109: /* sharedfunction: RENDER  */
#line 1050 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_RENDER_CACHE; }
#line 2779 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 110: /* sharedfunction: HDC_RO  */
#line 1051 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_HDC_READ_ONLY; }
#line 2785 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 111: /* sharedfunction: HDC0  */
#line 1052 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_HDC0; }
#line 2791 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 112: /* sharedfunction: PIXEL_INTERP  */
#line 1053 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_PIXEL_INTERPOLATOR; }
#line 2797 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 113: /* sharedfunction: HDC1  */
#line 1054 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_HDC1; }
#line 2803 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 114: /* sharedfunction: SAMPLER  */
#line 1055 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_SAMPLER; }
#line 2809 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 115: /* sharedfunction: HDC2  */
#line 1056 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_HDC2; }
#line 2815 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 116: /* sharedfunction: RT_ACCEL  */
#line 1057 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_RAY_TRACE_ACCELERATOR; }
#line 2821 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 117: /* sharedfunction: SLM  */
#line 1058 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_SLM; }
#line 2827 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 118: /* sharedfunction: TGM  */
#line 1059 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_TGM; }
#line 2833 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 119: /* sharedfunction: UGM  */
#line 1060 "../src/intel/compiler/brw_gram.y"
                       { (yyval.integer) = BRW_SFID_UGM; }
#line 2839 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 120: /* exp2: LONG  */
#line 1064 "../src/intel/compiler/brw_gram.y"
              { (yyval.llint) = (yyvsp[0].llint); }
#line 2845 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 121: /* exp2: MINUS LONG  */
#line 1065 "../src/intel/compiler/brw_gram.y"
                   { (yyval.llint) = -(yyvsp[0].llint); }
#line 2851 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 123: /* desc: exp2  */
#line 1071 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = brw_imm_ud((yyvsp[0].llint));
   }
#line 2859 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 125: /* ex_desc: exp2  */
#line 1079 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = brw_imm_ud((yyvsp[0].llint));
   }
#line 2867 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 126: /* reg32a: addrreg region reg_type  */
#line 1086 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
      (yyval.reg) = stride((yyval.reg), (yyvsp[-1].reg).vstride, (yyvsp[-1].reg).width, (yyvsp[-1].reg).hstride);
   }
#line 2876 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 127: /* jumpinstruction: predicate JMPI execsize relativelocation2 instoptions  */
#line 1096 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-3].integer));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_set_dest(p, brw_last_inst, brw_ip_reg());
      brw_set_src0(p, brw_last_inst, brw_ip_reg());
      brw_set_src1(p, brw_last_inst, (yyvsp[-1].reg));
      brw_eu_inst_set_pred_control(p->devinfo, brw_last_inst,
                                   brw_eu_inst_pred_control(p->devinfo, brw_last_inst));
      brw_pop_insn_state(p);
   }
#line 2892 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 128: /* branchinstruction: predicate ENDIF execsize JIP JUMP_LABEL instoptions  */
#line 1112 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-4].integer));
      brw_asm_label_use_jip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-3].integer));

      brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));

      brw_pop_insn_state(p);
   }
#line 2907 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 129: /* branchinstruction: ELSE execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1123 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-6].integer));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));

      brw_set_dest(p, brw_last_inst, retype(brw_null_reg(), BRW_TYPE_D));
      if (p->devinfo->ver < 12)
         brw_set_src0(p, brw_last_inst, brw_imm_d(0));
   }
#line 2923 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 130: /* branchinstruction: predicate IF execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1135 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-6].integer));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));

      brw_set_dest(p, brw_last_inst, vec1(retype(brw_null_reg(), BRW_TYPE_D)));
      if (p->devinfo->ver < 12)
         brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));

      brw_pop_insn_state(p);
   }
#line 2941 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 131: /* branchinstruction: predicate GOTO execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1149 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-6].integer));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));

      brw_pop_insn_state(p);
   }
#line 2955 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 132: /* joininstruction: predicate JOIN execsize JIP JUMP_LABEL instoptions  */
#line 1162 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-4].integer));
      brw_asm_label_use_jip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-3].integer));

      brw_pop_insn_state(p);
   }
#line 2968 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 133: /* breakinstruction: predicate BREAK execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1175 "../src/intel/compiler/brw_gram.y"
   {

      brw_next_insn(p, (yyvsp[-6].integer));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));

      brw_set_dest(p, brw_last_inst, retype(brw_null_reg(), BRW_TYPE_D));
      brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));

      brw_pop_insn_state(p);
   }
#line 2986 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 134: /* breakinstruction: predicate HALT execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1189 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-6].integer));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));

      brw_set_dest(p, brw_last_inst, retype(brw_null_reg(), BRW_TYPE_D));

      if (p->devinfo->ver < 12) {
         brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));
      }

      brw_pop_insn_state(p);
   }
#line 3006 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 135: /* breakinstruction: predicate CONT execsize JIP JUMP_LABEL UIP JUMP_LABEL instoptions  */
#line 1205 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-6].integer));
      brw_asm_label_use_jip((yyvsp[-3].string));
      brw_asm_label_use_uip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-5].integer));
      brw_set_dest(p, brw_last_inst, brw_ip_reg());

      brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));

      brw_pop_insn_state(p);
   }
#line 3023 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 136: /* loopinstruction: predicate WHILE execsize JIP JUMP_LABEL instoptions  */
#line 1222 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-4].integer));
      brw_asm_label_use_jip((yyvsp[-1].string));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-3].integer));

      brw_set_dest(p, brw_last_inst, retype(brw_null_reg(), BRW_TYPE_D));
      if (p->devinfo->ver < 12)
         brw_set_src0(p, brw_last_inst, brw_imm_d(0x0));

      brw_pop_insn_state(p);
   }
#line 3040 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 137: /* loopinstruction: DO execsize instoptions  */
#line 1235 "../src/intel/compiler/brw_gram.y"
   {
      brw_next_insn(p, (yyvsp[-2].integer));
   }
#line 3048 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 138: /* syncinstruction: predicate SYNC sync_function execsize sync_arg instoptions  */
#line 1243 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver < 12) {
         error(&(yylsp[-4]), "sync instruction is supported only on gfx12+\n");
      }

      if ((yyvsp[-1].reg).file == IMM &&
          (yyvsp[-3].integer) != TGL_SYNC_ALLRD &&
          (yyvsp[-3].integer) != TGL_SYNC_ALLWR) {
         error(&(yylsp[-4]), "Only allrd and allwr support immediate argument\n");
      }

      brw_set_default_access_mode(p, (yyvsp[0].options).access_mode);
      brw_SYNC(p, (yyvsp[-3].integer));
      i965_asm_set_instruction_options(p, (yyvsp[0].options));
      brw_eu_inst_set_exec_size(p->devinfo, brw_last_inst, (yyvsp[-2].integer));
      brw_set_src0(p, brw_last_inst, (yyvsp[-1].reg));
      brw_eu_inst_set_eot(p->devinfo, brw_last_inst, (yyvsp[0].options).end_of_thread);
      brw_eu_inst_set_group(p->devinfo, brw_last_inst, (yyvsp[0].options).chan_offset);

      brw_pop_insn_state(p);
   }
#line 3074 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 139: /* sync_function: NOP  */
#line 1267 "../src/intel/compiler/brw_gram.y"
            { (yyval.integer) = TGL_SYNC_NOP; }
#line 3080 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 145: /* sync_arg: nullreg region reg_type  */
#line 1277 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[-2].reg);
      (yyval.reg).vstride = (yyvsp[-1].reg).vstride;
      (yyval.reg).width = (yyvsp[-1].reg).width;
      (yyval.reg).hstride = (yyvsp[-1].reg).hstride;
      (yyval.reg).type = (yyvsp[0].reg_type);
   }
#line 3092 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 149: /* jumplabeltarget: JUMP_LABEL_TARGET  */
#line 1295 "../src/intel/compiler/brw_gram.y"
   {
      brw_asm_label_set((yyvsp[0].string));
   }
#line 3100 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 152: /* dstoperand: dstreg dstregion writemask reg_type  */
#line 1308 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[-3].reg);
      (yyval.reg).vstride = BRW_VERTICAL_STRIDE_1;
      (yyval.reg).width = BRW_WIDTH_1;
      (yyval.reg).hstride = (yyvsp[-2].integer);
      (yyval.reg).type = (yyvsp[0].reg_type);
      (yyval.reg).writemask = (yyvsp[-1].integer);
      (yyval.reg).swizzle = BRW_SWIZZLE_NOOP;
      (yyval.reg).subnr = (yyval.reg).subnr * brw_type_size_bytes((yyvsp[0].reg_type));
   }
#line 3115 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 153: /* dstoperandex: dstoperandex_typed dstregion writemask reg_type  */
#line 1322 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[-3].reg);
      (yyval.reg).hstride = (yyvsp[-2].integer);
      (yyval.reg).type = (yyvsp[0].reg_type);
      (yyval.reg).writemask = (yyvsp[-1].integer);
      (yyval.reg).subnr = (yyval.reg).subnr * brw_type_size_bytes((yyvsp[0].reg_type));
   }
#line 3127 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 154: /* dstoperandex: nullreg dstregion writemask reg_type  */
#line 1334 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[-3].reg);
      (yyval.reg).vstride = BRW_VERTICAL_STRIDE_1;
      (yyval.reg).width = BRW_WIDTH_1;
      (yyval.reg).hstride = (yyvsp[-2].integer);
      (yyval.reg).writemask = (yyvsp[-1].integer);
      (yyval.reg).type = (yyvsp[0].reg_type);
   }
#line 3140 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 155: /* dstoperandex: threadcontrolreg  */
#line 1343 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[0].reg);
      (yyval.reg).hstride = 1;
      (yyval.reg).type = BRW_TYPE_UW;
   }
#line 3150 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 167: /* dstreg: directgenreg  */
#line 1366 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[0].reg);
      (yyval.reg).address_mode = BRW_ADDRESS_DIRECT;
   }
#line 3159 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 168: /* dstreg: indirectgenreg  */
#line 1371 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = (yyvsp[0].reg);
      (yyval.reg).address_mode = BRW_ADDRESS_REGISTER_INDIRECT_REGISTER;
   }
#line 3168 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 171: /* immreg: immval imm_type  */
#line 1385 "../src/intel/compiler/brw_gram.y"
   {
      switch ((yyvsp[0].reg_type)) {
      case BRW_TYPE_UD:
         (yyval.reg) = brw_imm_ud((yyvsp[-1].llint));
         break;
      case BRW_TYPE_D:
         (yyval.reg) = brw_imm_d((yyvsp[-1].llint));
         break;
      case BRW_TYPE_UW:
         (yyval.reg) = brw_imm_uw((yyvsp[-1].llint) | ((yyvsp[-1].llint) << 16));
         break;
      case BRW_TYPE_W:
         (yyval.reg) = brw_imm_w((yyvsp[-1].llint));
         break;
      case BRW_TYPE_F:
         (yyval.reg) = brw_imm_reg(BRW_TYPE_F);
         /* Set u64 instead of ud since DIM uses a 64-bit F-typed imm */
         (yyval.reg).u64 = (yyvsp[-1].llint);
         break;
      case BRW_TYPE_V:
         (yyval.reg) = brw_imm_v((yyvsp[-1].llint));
         break;
      case BRW_TYPE_UV:
         (yyval.reg) = brw_imm_uv((yyvsp[-1].llint));
         break;
      case BRW_TYPE_VF:
         (yyval.reg) = brw_imm_vf((yyvsp[-1].llint));
         break;
      case BRW_TYPE_Q:
         (yyval.reg) = brw_imm_q((yyvsp[-1].llint));
         break;
      case BRW_TYPE_UQ:
         (yyval.reg) = brw_imm_uq((yyvsp[-1].llint));
         break;
      case BRW_TYPE_DF:
         (yyval.reg) = brw_imm_reg(BRW_TYPE_DF);
         (yyval.reg).d64 = (yyvsp[-1].llint);
         break;
      case BRW_TYPE_HF:
         (yyval.reg) = brw_imm_reg(BRW_TYPE_HF);
         (yyval.reg).ud = (yyvsp[-1].llint) | ((yyvsp[-1].llint) << 16);
         break;
      default:
         error(&(yylsp[0]), "Unknown immediate type %s\n",
               brw_reg_type_to_letters((yyvsp[0].reg_type)));
      }
   }
#line 3220 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 172: /* reg32: directgenreg region reg_type  */
#line 1436 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
      (yyval.reg) = stride((yyval.reg), (yyvsp[-1].reg).vstride, (yyvsp[-1].reg).width, (yyvsp[-1].reg).hstride);
   }
#line 3229 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 182: /* directsrcaccoperand: negate abs accreg region reg_type  */
#line 1465 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
      (yyval.reg).negate = (yyvsp[-4].integer);
      (yyval.reg).abs = (yyvsp[-3].integer);
      (yyval.reg).vstride = (yyvsp[-1].reg).vstride;
      (yyval.reg).width = (yyvsp[-1].reg).width;
      (yyval.reg).hstride = (yyvsp[-1].reg).hstride;
   }
#line 3242 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 183: /* srcarcoperandex: srcarcoperandex_typed region reg_type  */
#line 1477 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = brw_make_reg((yyvsp[-2].reg).file,
                        (yyvsp[-2].reg).nr,
                        (yyvsp[-2].reg).subnr,
                        0,
                        0,
                        (yyvsp[0].reg_type),
                        (yyvsp[-1].reg).vstride,
                        (yyvsp[-1].reg).width,
                        (yyvsp[-1].reg).hstride,
                        BRW_SWIZZLE_NOOP,
                        WRITEMASK_XYZW);
   }
#line 3260 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 184: /* srcarcoperandex: nullreg region reg_type  */
#line 1491 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = set_direct_src_operand(&(yyvsp[-2].reg), (yyvsp[0].reg_type));
      (yyval.reg).vstride = (yyvsp[-1].reg).vstride;
      (yyval.reg).width = (yyvsp[-1].reg).width;
      (yyval.reg).hstride = (yyvsp[-1].reg).hstride;
   }
#line 3271 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 185: /* srcarcoperandex: threadcontrolreg  */
#line 1498 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = set_direct_src_operand(&(yyvsp[0].reg), BRW_TYPE_UW);
   }
#line 3279 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 193: /* indirectsrcoperand: negate abs indirectgenreg indirectregion swizzle reg_type  */
#line 1515 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = brw_make_reg((yyvsp[-3].reg).file,
                        0,
                        (yyvsp[-3].reg).subnr,
                        (yyvsp[-5].integer),  // negate
                        (yyvsp[-4].integer),  // abs
                        (yyvsp[0].reg_type),
                        (yyvsp[-2].reg).vstride,
                        (yyvsp[-2].reg).width,
                        (yyvsp[-2].reg).hstride,
                        (yyvsp[-1].integer),
                        WRITEMASK_X);

      (yyval.reg).address_mode = BRW_ADDRESS_REGISTER_INDIRECT_REGISTER;
      // brw_reg set indirect_offset to 0 so set it to valid value
      (yyval.reg).indirect_offset = (yyvsp[-3].reg).indirect_offset;
   }
#line 3301 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 198: /* directsrcoperand: negate abs directgenreg_list region swizzle reg_type  */
#line 1543 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = brw_make_reg((yyvsp[-3].reg).file,
                        (yyvsp[-3].reg).nr,
                        (yyvsp[-3].reg).subnr,
                        (yyvsp[-5].integer),
                        (yyvsp[-4].integer),
                        (yyvsp[0].reg_type),
                        (yyvsp[-2].reg).vstride,
                        (yyvsp[-2].reg).width,
                        (yyvsp[-2].reg).hstride,
                        (yyvsp[-1].integer),
                        WRITEMASK_X);
   }
#line 3319 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 200: /* addrparam: addrreg exp  */
#line 1562 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
      (yyval.reg).subnr = (yyvsp[-1].reg).subnr;
      (yyval.reg).indirect_offset = (yyvsp[0].integer);
   }
#line 3329 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 202: /* exp: INTEGER  */
#line 1572 "../src/intel/compiler/brw_gram.y"
              { (yyval.integer) = (yyvsp[0].integer); }
#line 3335 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 203: /* exp: LONG  */
#line 1573 "../src/intel/compiler/brw_gram.y"
              { (yyval.integer) = (yyvsp[0].llint); }
#line 3341 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 204: /* subregnum: DOT exp  */
#line 1577 "../src/intel/compiler/brw_gram.y"
                                    { (yyval.integer) = (yyvsp[0].integer); }
#line 3347 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 205: /* subregnum: %empty  */
#line 1578 "../src/intel/compiler/brw_gram.y"
                                    { (yyval.integer) = 0; }
#line 3353 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 206: /* directgenreg: GENREG subregnum  */
#line 1583 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
      (yyval.reg).file = FIXED_GRF;
      (yyval.reg).nr = (yyvsp[-1].integer) * reg_unit(p->devinfo);
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3364 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 207: /* indirectgenreg: GENREGFILE LSQUARE addrparam RSQUARE  */
#line 1593 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
      (yyval.reg).file = FIXED_GRF;
      (yyval.reg).subnr = (yyvsp[-1].reg).subnr;
      (yyval.reg).indirect_offset = (yyvsp[-1].reg).indirect_offset;
   }
#line 3375 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 208: /* addrreg: ADDRREG subregnum  */
#line 1603 "../src/intel/compiler/brw_gram.y"
   {
      int subnr = 16;

      if ((yyvsp[0].integer) > subnr)
         error(&(yylsp[0]), "Address sub register number %d"
               "out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_ADDRESS;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3391 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 209: /* accreg: ACCREG subregnum  */
#line 1618 "../src/intel/compiler/brw_gram.y"
   {
      int nr_reg = 10;

      if ((yyvsp[-1].integer) > nr_reg)
         error(&(yylsp[-1]), "Accumulator register number %d"
               " out of range\n", (yyvsp[-1].integer));

      memset(&(yyval.reg), '\0', sizeof((yyval.reg)));
      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_ACCUMULATOR;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3408 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 210: /* flagreg: FLAGREG subregnum  */
#line 1634 "../src/intel/compiler/brw_gram.y"
   {
      // 2 flag reg
      int nr_reg = 2;
      int subnr = nr_reg;

      if ((yyvsp[-1].integer) > nr_reg)
         error(&(yylsp[-1]), "Flag register number %d"
               " out of range \n", (yyvsp[-1].integer));
      if ((yyvsp[0].integer) > subnr)
         error(&(yylsp[0]), "Flag subregister number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_FLAG | (yyvsp[-1].integer);
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3429 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 211: /* maskreg: MASKREG subregnum  */
#line 1654 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].integer) > 0)
         error(&(yylsp[-1]), "Mask register number %d"
               " out of range\n", (yyvsp[-1].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_MASK;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3443 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 212: /* notifyreg: NOTIFYREG subregnum  */
#line 1667 "../src/intel/compiler/brw_gram.y"
   {
      int subnr = (p->devinfo->ver >= 11) ? 2 : 3;
      if ((yyvsp[0].integer) > subnr)
         error(&(yylsp[0]), "Notification sub register number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_NOTIFICATION_COUNT;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3458 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 213: /* scalarreg: SCALARREG subregnum  */
#line 1681 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[0].integer) > 31)
         error(&(yylsp[0]), "Scalar sub register number %d"
                    " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_SCALAR;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3472 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 214: /* statereg: STATEREG subregnum  */
#line 1693 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].integer) > 2)
         error(&(yylsp[-1]), "State register number %d"
               " out of range\n", (yyvsp[-1].integer));

      if ((yyvsp[0].integer) > 4)
         error(&(yylsp[0]), "State sub register number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_STATE;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3490 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 215: /* controlreg: CONTROLREG subregnum  */
#line 1710 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[0].integer) > 3)
         error(&(yylsp[0]), "control sub register number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_CONTROL;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3504 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 216: /* ipreg: IPREG  */
#line 1722 "../src/intel/compiler/brw_gram.y"
              { (yyval.reg) = brw_ip_reg(); }
#line 3510 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 217: /* nullreg: NULL_TOKEN  */
#line 1726 "../src/intel/compiler/brw_gram.y"
                 { (yyval.reg) = brw_null_reg(); }
#line 3516 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 218: /* threadcontrolreg: THREADREG subregnum  */
#line 1731 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[0].integer) > 7)
         error(&(yylsp[0]), "Thread control sub register number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_TDR;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3530 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 219: /* performancereg: PERFORMANCEREG subregnum  */
#line 1744 "../src/intel/compiler/brw_gram.y"
   {
      int subnr;
      if (p->devinfo->ver >= 10)
         subnr = 5;
      else
         subnr = 4;

      if ((yyvsp[0].integer) > subnr)
         error(&(yylsp[0]), "Performance sub register number %d"
               " out of range\n", (yyvsp[0].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_TIMESTAMP;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3550 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 220: /* channelenablereg: CHANNELENABLEREG subregnum  */
#line 1763 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].integer) > 0)
         error(&(yylsp[-1]), "Channel enable register number %d"
               " out of range\n", (yyvsp[-1].integer));

      (yyval.reg).file = ARF;
      (yyval.reg).nr = BRW_ARF_MASK;
      (yyval.reg).subnr = (yyvsp[0].integer);
   }
#line 3564 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 221: /* immval: exp2  */
#line 1777 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.llint) = (yyvsp[0].llint);
   }
#line 3572 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 222: /* immval: LSQUARE exp2 COMMA exp2 COMMA exp2 COMMA exp2 RSQUARE  */
#line 1781 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.llint) = ((yyvsp[-7].llint) << 0) | ((yyvsp[-5].llint) << 8) | ((yyvsp[-3].llint) << 16) | ((yyvsp[-1].llint) << 24);
   }
#line 3580 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 223: /* dstregion: %empty  */
#line 1789 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = BRW_HORIZONTAL_STRIDE_1;
   }
#line 3588 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 224: /* dstregion: LANGLE exp RANGLE  */
#line 1793 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid Horizontal stride %d\n", (yyvsp[-1].integer));

      (yyval.integer) = ffs((yyvsp[-1].integer));
   }
#line 3599 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 227: /* region: %empty  */
#line 1808 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.reg) = stride((yyval.reg), 0, 1, 0);
   }
#line 3607 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 228: /* region: LANGLE exp RANGLE  */
#line 1812 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 32 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid VertStride %d\n", (yyvsp[-1].integer));

      (yyval.reg) = stride((yyval.reg), (yyvsp[-1].integer), 1, 0);
   }
#line 3618 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 229: /* region: LANGLE exp COMMA exp COMMA exp RANGLE  */
#line 1819 "../src/intel/compiler/brw_gram.y"
   {

      if ((yyvsp[-5].integer) != 0 && ((yyvsp[-5].integer) > 32 || !isPowerofTwo((yyvsp[-5].integer))))
         error(&(yylsp[-5]), "Invalid VertStride %d\n", (yyvsp[-5].integer));

      if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
         error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid Horizontal stride in"
               "  region_wh %d\n", (yyvsp[-1].integer));

      (yyval.reg) = stride((yyval.reg), (yyvsp[-5].integer), (yyvsp[-3].integer), (yyvsp[-1].integer));
   }
#line 3637 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 230: /* region: LANGLE exp SEMICOLON exp COMMA exp RANGLE  */
#line 1834 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-5].integer) != 0 && ((yyvsp[-5].integer) > 32 || !isPowerofTwo((yyvsp[-5].integer))))
         error(&(yylsp[-5]), "Invalid VertStride %d\n", (yyvsp[-5].integer));

      if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
         error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid Horizontal stride in"
               " region_wh %d\n", (yyvsp[-1].integer));

      (yyval.reg) = stride((yyval.reg), (yyvsp[-5].integer), (yyvsp[-3].integer), (yyvsp[-1].integer));
   }
#line 3655 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 231: /* region: LANGLE VxH COMMA exp COMMA exp RANGLE  */
#line 1848 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
         error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid Horizontal stride in"
               " region_wh %d\n", (yyvsp[-1].integer));

      (yyval.reg) = brw_VxH_indirect(0, 0);
   }
#line 3670 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 232: /* region_wh: LANGLE exp COMMA exp RANGLE  */
#line 1862 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-3].integer) > 16 || !isPowerofTwo((yyvsp[-3].integer)))
         error(&(yylsp[-3]), "Invalid width %d\n", (yyvsp[-3].integer));

      if ((yyvsp[-1].integer) != 0 && ((yyvsp[-1].integer) > 4 || !isPowerofTwo((yyvsp[-1].integer))))
         error(&(yylsp[-1]), "Invalid Horizontal stride in"
               " region_wh %d\n", (yyvsp[-1].integer));

      (yyval.reg) = stride((yyval.reg), 0, (yyvsp[-3].integer), (yyvsp[-1].integer));
      (yyval.reg).vstride = BRW_VERTICAL_STRIDE_ONE_DIMENSIONAL;
   }
#line 3686 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 233: /* reg_type: TYPE_F  */
#line 1876 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_F;  }
#line 3692 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 234: /* reg_type: TYPE_UD  */
#line 1877 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_UD; }
#line 3698 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 235: /* reg_type: TYPE_D  */
#line 1878 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_D;  }
#line 3704 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 236: /* reg_type: TYPE_UW  */
#line 1879 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_UW; }
#line 3710 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 237: /* reg_type: TYPE_W  */
#line 1880 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_W;  }
#line 3716 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 238: /* reg_type: TYPE_UB  */
#line 1881 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_UB; }
#line 3722 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 239: /* reg_type: TYPE_B  */
#line 1882 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_B;  }
#line 3728 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 240: /* reg_type: TYPE_DF  */
#line 1883 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_DF; }
#line 3734 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 241: /* reg_type: TYPE_UQ  */
#line 1884 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_UQ; }
#line 3740 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 242: /* reg_type: TYPE_Q  */
#line 1885 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_Q;  }
#line 3746 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 243: /* reg_type: TYPE_HF  */
#line 1886 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_HF; }
#line 3752 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 244: /* reg_type: TYPE_BF  */
#line 1887 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_BF; }
#line 3758 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 245: /* imm_type: reg_type  */
#line 1891 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = (yyvsp[0].reg_type); }
#line 3764 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 246: /* imm_type: TYPE_V  */
#line 1892 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_V;  }
#line 3770 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 247: /* imm_type: TYPE_VF  */
#line 1893 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_VF; }
#line 3776 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 248: /* imm_type: TYPE_UV  */
#line 1894 "../src/intel/compiler/brw_gram.y"
               { (yyval.reg_type) = BRW_TYPE_UV; }
#line 3782 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 249: /* writemask: %empty  */
#line 1899 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = WRITEMASK_XYZW;
   }
#line 3790 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 250: /* writemask: DOT writemask_x writemask_y writemask_z writemask_w  */
#line 1903 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = (yyvsp[-3].integer) | (yyvsp[-2].integer) | (yyvsp[-1].integer) | (yyvsp[0].integer);
   }
#line 3798 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 251: /* writemask_x: %empty  */
#line 1909 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 0; }
#line 3804 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 252: /* writemask_x: X  */
#line 1910 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 1 << BRW_CHANNEL_X; }
#line 3810 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 253: /* writemask_y: %empty  */
#line 1914 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 0; }
#line 3816 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 254: /* writemask_y: Y  */
#line 1915 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 1 << BRW_CHANNEL_Y; }
#line 3822 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 255: /* writemask_z: %empty  */
#line 1919 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 0; }
#line 3828 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 256: /* writemask_z: Z  */
#line 1920 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 1 << BRW_CHANNEL_Z; }
#line 3834 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 257: /* writemask_w: %empty  */
#line 1924 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 0; }
#line 3840 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 258: /* writemask_w: W  */
#line 1925 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = 1 << BRW_CHANNEL_W; }
#line 3846 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 259: /* swizzle: %empty  */
#line 1930 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = BRW_SWIZZLE_NOOP;
   }
#line 3854 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 260: /* swizzle: DOT chansel  */
#line 1934 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = BRW_SWIZZLE4((yyvsp[0].integer), (yyvsp[0].integer), (yyvsp[0].integer), (yyvsp[0].integer));
   }
#line 3862 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 261: /* swizzle: DOT chansel chansel chansel chansel  */
#line 1938 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = BRW_SWIZZLE4((yyvsp[-3].integer), (yyvsp[-2].integer), (yyvsp[-1].integer), (yyvsp[0].integer));
   }
#line 3870 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 266: /* predicate: %empty  */
#line 1953 "../src/intel/compiler/brw_gram.y"
   {
      brw_push_insn_state(p);
      brw_set_default_predicate_control(p, BRW_PREDICATE_NONE);
      brw_set_default_flag_reg(p, 0, 0);
      brw_set_default_predicate_inverse(p, false);
   }
#line 3881 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 267: /* predicate: LPAREN predstate flagreg predctrl RPAREN  */
#line 1960 "../src/intel/compiler/brw_gram.y"
   {
      brw_push_insn_state(p);
      brw_set_default_predicate_inverse(p, (yyvsp[-3].integer));
      brw_set_default_flag_reg(p, (yyvsp[-2].reg).nr, (yyvsp[-2].reg).subnr);
      brw_set_default_predicate_control(p, (yyvsp[-1].integer));
   }
#line 3892 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 268: /* predstate: %empty  */
#line 1969 "../src/intel/compiler/brw_gram.y"
                   { (yyval.integer) = 0; }
#line 3898 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 269: /* predstate: PLUS  */
#line 1970 "../src/intel/compiler/brw_gram.y"
                   { (yyval.integer) = 0; }
#line 3904 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 270: /* predstate: MINUS  */
#line 1971 "../src/intel/compiler/brw_gram.y"
                   { (yyval.integer) = 1; }
#line 3910 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 271: /* predctrl: %empty  */
#line 1975 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_PREDICATE_NORMAL; }
#line 3916 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 272: /* predctrl: DOT X  */
#line 1976 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_PREDICATE_ALIGN16_REPLICATE_X; }
#line 3922 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 273: /* predctrl: DOT Y  */
#line 1977 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_PREDICATE_ALIGN16_REPLICATE_Y; }
#line 3928 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 274: /* predctrl: DOT Z  */
#line 1978 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_PREDICATE_ALIGN16_REPLICATE_Z; }
#line 3934 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 275: /* predctrl: DOT W  */
#line 1979 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_PREDICATE_ALIGN16_REPLICATE_W; }
#line 3940 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 288: /* negate: %empty  */
#line 1996 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = 0; }
#line 3946 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 289: /* negate: MINUS  */
#line 1997 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = 1; }
#line 3952 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 290: /* abs: %empty  */
#line 2001 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = 0; }
#line 3958 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 291: /* abs: ABS  */
#line 2002 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = 1; }
#line 3964 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 292: /* cond_mod: condModifiers  */
#line 2008 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.condition).cond_modifier = (yyvsp[0].integer);
      (yyval.condition).flag_reg_nr = 0;
      (yyval.condition).flag_subreg_nr = 0;
   }
#line 3974 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 293: /* cond_mod: condModifiers DOT flagreg  */
#line 2014 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.condition).cond_modifier = (yyvsp[-2].integer);
      (yyval.condition).flag_reg_nr = (yyvsp[0].reg).nr;
      (yyval.condition).flag_subreg_nr = (yyvsp[0].reg).subnr;
   }
#line 3984 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 294: /* condModifiers: %empty  */
#line 2022 "../src/intel/compiler/brw_gram.y"
                  { (yyval.integer) = BRW_CONDITIONAL_NONE; }
#line 3990 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 306: /* msgdesc: MSGDESC_BEGIN msgdesc_parts MSGDESC_END  */
#line 2038 "../src/intel/compiler/brw_gram.y"
                                           { (yyval.msgdesc) = (yyvsp[-1].msgdesc); }
#line 3996 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 307: /* msgdesc_parts: SRC1_LEN ASSIGN INTEGER msgdesc_parts  */
#line 2043 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.msgdesc) = (yyvsp[0].msgdesc);
      (yyval.msgdesc).src1_len = (yyvsp[-1].integer);
   }
#line 4005 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 308: /* msgdesc_parts: EX_BSO msgdesc_parts  */
#line 2048 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.msgdesc) = (yyvsp[0].msgdesc);
      (yyval.msgdesc).ex_bso = 1;
   }
#line 4014 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 309: /* msgdesc_parts: INTEGER msgdesc_parts  */
#line 2052 "../src/intel/compiler/brw_gram.y"
                           { (yyval.msgdesc) = (yyvsp[0].msgdesc); }
#line 4020 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 310: /* msgdesc_parts: ASSIGN msgdesc_parts  */
#line 2053 "../src/intel/compiler/brw_gram.y"
                          { (yyval.msgdesc) = (yyvsp[0].msgdesc); }
#line 4026 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 311: /* msgdesc_parts: %empty  */
#line 2055 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.msgdesc), 0, sizeof((yyval.msgdesc)));
   }
#line 4034 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 312: /* saturate: %empty  */
#line 2061 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = BRW_INSTRUCTION_NORMAL; }
#line 4040 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 313: /* saturate: SATURATE  */
#line 2062 "../src/intel/compiler/brw_gram.y"
                 { (yyval.integer) = BRW_INSTRUCTION_SATURATE; }
#line 4046 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 314: /* execsize: %empty  */
#line 2068 "../src/intel/compiler/brw_gram.y"
   {
      (yyval.integer) = 0;
   }
#line 4054 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 315: /* execsize: LPAREN exp2 RPAREN  */
#line 2072 "../src/intel/compiler/brw_gram.y"
   {
      if ((yyvsp[-1].llint) > 32 || !isPowerofTwo((yyvsp[-1].llint)))
         error(&(yylsp[-1]), "Invalid execution size %llu\n", (yyvsp[-1].llint));

      (yyval.integer) = cvt((yyvsp[-1].llint)) - 1;
   }
#line 4065 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 316: /* instoptions: %empty  */
#line 2083 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.options), 0, sizeof((yyval.options)));
   }
#line 4073 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 317: /* instoptions: LCURLY instoption_list RCURLY  */
#line 2087 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.options), 0, sizeof((yyval.options)));
      (yyval.options) = (yyvsp[-1].options);
   }
#line 4082 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 318: /* instoption_list: instoption_list COMMA instoption  */
#line 2095 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.options), 0, sizeof((yyval.options)));
      (yyval.options) = (yyvsp[-2].options);
      add_instruction_option(&(yyval.options), (yyvsp[0].instoption));
   }
#line 4092 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 319: /* instoption_list: instoption_list instoption  */
#line 2101 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.options), 0, sizeof((yyval.options)));
      (yyval.options) = (yyvsp[-1].options);
      add_instruction_option(&(yyval.options), (yyvsp[0].instoption));
   }
#line 4102 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 320: /* instoption_list: %empty  */
#line 2107 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.options), 0, sizeof((yyval.options)));
   }
#line 4110 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 321: /* depinfo: REG_DIST_CURRENT  */
#line 2114 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_NONE;
   }
#line 4120 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 322: /* depinfo: REG_DIST_FLOAT  */
#line 2120 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_FLOAT;
   }
#line 4130 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 323: /* depinfo: REG_DIST_INT  */
#line 2126 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_INT;
   }
#line 4140 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 324: /* depinfo: REG_DIST_LONG  */
#line 2132 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_LONG;
   }
#line 4150 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 325: /* depinfo: REG_DIST_ALL  */
#line 2138 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_ALL;
   }
#line 4160 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 326: /* depinfo: REG_DIST_MATH  */
#line 2144 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_MATH;
   }
#line 4170 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 327: /* depinfo: REG_DIST_SCALAR  */
#line 2150 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).regdist = (yyvsp[0].integer);
      (yyval.depinfo).pipe = TGL_PIPE_SCALAR;
   }
#line 4180 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 328: /* depinfo: SBID_ALLOC  */
#line 2156 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).sbid = (yyvsp[0].integer);
      (yyval.depinfo).mode = TGL_SBID_SET;
   }
#line 4190 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 329: /* depinfo: SBID_WAIT_SRC  */
#line 2162 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).sbid = (yyvsp[0].integer);
      (yyval.depinfo).mode = TGL_SBID_SRC;
   }
#line 4200 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 330: /* depinfo: SBID_WAIT_DST  */
#line 2168 "../src/intel/compiler/brw_gram.y"
   {
      memset(&(yyval.depinfo), 0, sizeof((yyval.depinfo)));
      (yyval.depinfo).sbid = (yyvsp[0].integer);
      (yyval.depinfo).mode = TGL_SBID_DST;
   }
#line 4210 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 331: /* instoption: ALIGN1  */
#line 2175 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = ALIGN1;}
#line 4216 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 332: /* instoption: ALIGN16  */
#line 2176 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = ALIGN16; }
#line 4222 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 333: /* instoption: ACCWREN  */
#line 2178 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver >= 20)
         error(&(yylsp[0]), "AccWrEnable not supported in Xe2+\n");
      (yyval.instoption).type = INSTOPTION_FLAG;
      (yyval.instoption).uint_value = ACCWREN;
   }
#line 4233 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 334: /* instoption: BREAKPOINT  */
#line 2184 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = BREAKPOINT; }
#line 4239 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 335: /* instoption: NODDCLR  */
#line 2185 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = NODDCLR; }
#line 4245 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 336: /* instoption: NODDCHK  */
#line 2186 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = NODDCHK; }
#line 4251 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 337: /* instoption: MASK_DISABLE  */
#line 2187 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = MASK_DISABLE; }
#line 4257 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 338: /* instoption: EOT  */
#line 2188 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = EOT; }
#line 4263 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 339: /* instoption: SWITCH  */
#line 2189 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = SWITCH; }
#line 4269 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 340: /* instoption: ATOMIC  */
#line 2190 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = ATOMIC; }
#line 4275 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 341: /* instoption: BRANCH_CTRL  */
#line 2191 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = BRANCH_CTRL; }
#line 4281 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 342: /* instoption: CMPTCTRL  */
#line 2192 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = CMPTCTRL; }
#line 4287 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 343: /* instoption: WECTRL  */
#line 2193 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_FLAG; (yyval.instoption).uint_value = WECTRL; }
#line 4293 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 344: /* instoption: QTR_2Q  */
#line 2194 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 8; }
#line 4299 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 345: /* instoption: QTR_3Q  */
#line 2195 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 16; }
#line 4305 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 346: /* instoption: QTR_4Q  */
#line 2196 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 24; }
#line 4311 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 347: /* instoption: QTR_2H  */
#line 2197 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 16; }
#line 4317 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 348: /* instoption: QTR_2N  */
#line 2199 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver >= 20)
         error(&(yylsp[0]), "Channel offset must be multiple of 8 in Xe2+\n");
      (yyval.instoption).type = INSTOPTION_CHAN_OFFSET;
      (yyval.instoption).uint_value = 4;
   }
#line 4328 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 349: /* instoption: QTR_3N  */
#line 2205 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 8; }
#line 4334 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 350: /* instoption: QTR_4N  */
#line 2207 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver >= 20)
         error(&(yylsp[0]), "Channel offset must be multiple of 8 in Xe2+\n");
      (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 12;
   }
#line 4344 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 351: /* instoption: QTR_5N  */
#line 2212 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 16; }
#line 4350 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 352: /* instoption: QTR_6N  */
#line 2214 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver >= 20)
         error(&(yylsp[0]), "Channel offset must be multiple of 8 in Xe2+\n");
      (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 20;
   }
#line 4360 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 353: /* instoption: QTR_7N  */
#line 2219 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 24; }
#line 4366 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 354: /* instoption: QTR_8N  */
#line 2221 "../src/intel/compiler/brw_gram.y"
   {
      if (p->devinfo->ver >= 20)
         error(&(yylsp[0]), "Channel offset must be multiple of 8 in Xe2+\n");
      (yyval.instoption).type = INSTOPTION_CHAN_OFFSET; (yyval.instoption).uint_value = 28;
   }
#line 4376 "src/intel/compiler/brw_gram.tab.c"
    break;

  case 355: /* instoption: depinfo  */
#line 2226 "../src/intel/compiler/brw_gram.y"
                   { (yyval.instoption).type = INSTOPTION_DEP_INFO; (yyval.instoption).depinfo_value = (yyvsp[0].depinfo); }
#line 4382 "src/intel/compiler/brw_gram.tab.c"
    break;


#line 4386 "src/intel/compiler/brw_gram.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2229 "../src/intel/compiler/brw_gram.y"


extern int yylineno;

#ifdef YYBYACC
void
yyerror(YYLTYPE *ltype, char *msg)
#else
void
yyerror(char *msg)
#endif
{
   fprintf(stderr, "%s: %d: %s at \"%s\"\n",
           input_filename, yylineno, msg, lex_text());
   ++errors;
}
